;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;

;
; ************************************************************
;
;			Code of the Boss
;
; ************************************************************

; Try
; cmpa.l #(SCREEN_SIZE+5*128+1000),a7
; bls	ExitBoss	; La pile est surcharge : on quitte immdiatement !
			; User Stack : $0120

; Set the 2nd Screen
 lea	-(SCREEN_SIZE+8)(A7),a7	; On stocke le second cran dans la pile
 move.l a7,d0
 bsr	Init2ndScreen

; Make a tiny-Buffer for Fernando Test
 lea	-(5*128)(a7),a7	; 5 Rows of 128 Coloums
 move.l	a7,LevelTestADR(a6)
 move.l	a7,a0
 moveq	#(128*4/4-1),d0 ; 4 Rows cleared
\Loop0:
 clr.l	(a0)+
 dbf.s	d0,\Loop0
 moveq	#(128/4-1),d0
\Loop1:
 move.l	#$01010101,(a0)+
 dbf.s	d0,\Loop1
 lea	6(a7),a0
 moveq	#4,d0
\Loop2:
 move.b	#01,(a0)+
 lea	127(a0),a0
 dbf.s	d0,\Loop2

; Save a1 (File Adr) while Fernando's initialization
 move.l a1,-(a7)

; Init Fernando for boss
 moveq	#100,d1
 move.w	d1,Bj(a6)
 move.w	d1,StartX(a6)
 move.w	d1,StartY(a6)
 move.w	d1,BossLife(a6)		; Set BossLife
 bsr	Init_Fernando

; Restore a1 (File Adr)
 move.l	(a7)+,a1


; Load NbrElement & NbrPhase 
 moveq	#0,d0
 moveq	#0,d1
 move.b	(a1)+,d0
 move.w	d0,NbrElement(a6)
 move.b	(a1)+,d1
 addq.w	#1,d1
 move.w	d1,NbrPhase(a6)
 
 move.l a1,LevelADR(a6)

; Calcul de TaillePhase
 add.w	d0,d0
 addq.w	#(1+2*1),d0
 move.w	d0,TaillePhase(a6)

; Init data
 clr.l	Phase1(a6)	; Phase1 = 0 and Phase2 = 0
 addq.w	#1,Phase2(a6)	; Phase2 = 1
 move.l	a1,Phase1ADR(a6)
 adda.l	d0,a1
 move.l	a1,Phase2ADR(a6)

; Init Phase 0
 move.b	(a1),Vitesse(a6)

; Init all elements of the boss

 moveq	#0,d3
\Loop:
 moveq	#14,d0
 bsr	SpriteInit	; One element initialization
 addq.w	#1,d3
 cmp.w	NbrElement(a6),d3
 bls.s	\Loop

 clr.l	Xs(a6)		; Xs & Ys cleared

; Show Statut
 move.b #OK,Mort(a6)
 bsr	Statut
 moveq	#0,d7
 lea	Boss_Text(PC),a3
 bsr	DrawTextWithoutClear
 bsr	CopyTo2ndScreen
 SetFont NORMAL

; Clear Time
 clr.l	Clock(a6)

Boss_Loop:
 bsr	ChangeScreen

 clr.b	Refresh(a6)

 move.b #1,($600017)	; Set the processor' s clock to 1

; Clear Screen
 move.l	Screen(a6),a0
 moveq	#(SCREEN_Y-1),d1
\Y_Loop:
 moveq	#(SC_X/2-1),d0
\X_Loop:
 clr.w	(a0)+
 dbf.s	d0,\X_Loop
 NEXT_ROW a0
 dbf.s	d1,\Y_Loop

; Change Phase
 move.w	Time(a6),d0
 addq.w	#1,d0
 moveq	#1,d1
 move.b	Vitesse(a6),d2
 lsl.w	d2,d1
 cmp.w	d1,d0		; Number of frames = 2^Speed ?
 bne.s	\SkipChangePhase
 move.b	#1,Refresh(a6)	; yes, so all data of the boss must be refreshed
 move.l	Phase2ADR(a6),a0
 move.l	a0,Phase1ADR(a6) ; Copy Phase2 -> phase 1
 move.b	(a0),Vitesse(a6) ; Update new speed
 move.w	Phase2(a6),d1	; Copy phase2 -> Phase1
 move.w	d1,Phase1(a6)
 addq.w	#1,d1		; Update Phase 2
 cmp.w	NbrPhase(a6),d1	; phase2 < Number of phases ?
 bne.s	\NoBack
 clr.w	Phase2(a6)	; yes, so phase2 = 0
 move.l	LevelADR(a6),Phase2ADR(a6)
 bra.s	\Go
\NoBack:
 move.w	d1,Phase2(a6)	; Update phase2
 moveq	#0,d1
 move.w	TaillePhase(a6),d1
 add.l	d1,Phase2ADR(a6)
\Go:
 clr.w	d0
\SkipChangePhase:
 move.w	d0,Time(a6)

; Show some data if DEBUG
 ifeq	DEBUG-1
 move.l Phase1ADR(a6),d0
 moveq.l #1,d1
 moveq.l #10,d2
 moveq.l #6,d4
 jsr	hexlib::put_hex 

 move.l Phase2ADR(a6),d0
 moveq.l #2,d1
 moveq.l #10,d2
 moveq.l #6,d4
 jsr	hexlib::put_hex 

 move.l LevelADR(a6),d0
 moveq.l #3,d1
 moveq.l #10,d2
 moveq.l #6,d4
 jsr	hexlib::put_hex 
 endif

; Read the keys :
 bsr    GetKeyStat
 Exit_Key_Test
 bne.s	\skip
 move.b #QUICK_EXIT,Mort(a6)
\skip:
 Pause_Key_Test
 bne.s	\skip2
 movem.l d0-d7/a0-a6,-(a7)
 trap #4		; Pause and turn off the calc
 movem.l (a7)+,d0-d7/a0-a6
\skip2:

 bsr  SpriteGestion

 BOSS_SCROLL
 PUT_STATUT

 ifeq	CONTRAST-1
  bsr	Contrast
 endif

 move.b Frame_Time(A6),d0
\Wait
 cmp.b	($600017),d0	; Wait for the processor's clock
 bhi.s	\Wait

 cmpi.b #OK,Mort(a6)
 beq    Boss_Loop
; End of Main Loop

 cmp.b	#LEVEL_COMPLETED,Mort(a6)
 beq.s	\NoDec
 subq.w	#1,Vi(a6)
\NoDec:

; Restore correct Screen
 move.w	Table+2(A6),($600010)

 bsr	WaitForNotKey

; Pop the 2nd Screen & Tyni-Buffer
 lea	(SCREEN_SIZE+8+5*128)(a7),a7
ExitBoss:
