;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;****************************************************************************
;****************************************************************************
;
;			Calc-Level-Editor for Fer3c
;
;****************************************************************************
;****************************************************************************

	include	"tios.h"
	include "flib.h"
	include "hexlib.h"
	include "pk92lib.h"
	include	"fer3c.h"
	include "macros.h"

	include "sprite.h"

	include "options.h"

	xdef	_library
	xdef	fer3edit@0000

	include "Fer3edit.h"

fer3edit@0000:
	lea	fer3c::Variable,a6	; acces to fer3c var
	lea	My_Data(PC),a5		; acces to fer3edit var

	move.l	a1,GraphCAdr(a5)
	move.l	a0,StartAdr(a5)
	addq.l	#2,a0
	move.l	a0,LevelEditADR(a5)

Main_Loop:
	clr.b	BoxON(a5)
	clr.b	ExitBool(a5)
	move.w	#(SCR_X/4-2),D_SCR_X(a5)
	move.w	#(SCREEN_Y/32-1),D_SCR_Y(a5)

	jsr	flib::zap_screen

	moveq	#0,d0
	lea	GraphTest(PC),a0	; Adr a0
	jsr     pk92lib::Extract
	tst.b	d0	; Ok ?
	bne.s	ExitPK92
	move.w	d1,-(a7); Save the handle on the stack in order to be deleted before quitting
	move.l	a1,GraphTestADR(a5)

	moveq	#0,d0
	move.l	GraphCAdr(a5),a0	; Adr a0
	jsr     pk92lib::Extract
	tst.b	d0	; Ok ?
	bne.s	Exit2PK92

	move.w	d1,-(a7)	; Save the handle on the stack in order to be deleted before quitting
	move.l	a1,GraphEditADR(a5)

\Conti:
	bsr	Action
	tst.b	ExitBool(a5)
	beq.s	\Conti

	jsr	tios::HeapFree
	addq.l	#2,a7
Exit2PK92:
	jsr	tios::HeapFree
	addq.l	#2,a7
ExitPK92:

End_Main_Loop:

	cmp.b	#2,ExitBool(a5)
	bne	\Exit
; A1 pointe vers le niveau
; A5 vers les graphs compresses
; A6 vers les variables
; SpriteAdr vers un buffer libre de SPRITE_BUFFER
; SpriteAdrEnd (SpriteAdr+4) vers ce meme buffer
; SpriteInit+6 vers la fin de ce buffer

; If we know the Handle of the I/O we will use it, else we will use a buffer
 ifeq	HANDLEOK-1
 moveq	#(4*HANDLEIO),d0	; Set Sprite-Buffer : I/O Screen
 move.l	tios::Heap,a1		; Insert tios::DEREF Macro
 move.l	0(a1,d0.w),a1		; and optimize it to be shorter...
 addq.l	#4,a1			; Find Adress of I/O Screen
 endif

 ifeq	HANDLEOK
 pea	(SPRITE_BUFFER+2*MAX_SPRITE_SIZE).w
 jsr	tios::HeapAlloc
 addq.l	#4,a7
 tst.l	d0
 bne.s	\Ok
 rts
\Ok:
 move.w	d0,-(a7)	; we will destroy it before quitting
 tios::DEREF  d0,a1
 endif

	clr.w	NbrJoueur(a6)		; No cooperation mode
	clr.b	Link(a6)		; No competition mode
	clr.b	Mort(a6)		; No big-level

	move.l	a1,SpriteADR(a6)
	move.l	a1,SpriteADREnd(a6)
	lea	SPRITE_BUFFER(a1),a1		; Adr of the end of the buffer
	move.l	a1,fer3c::SpriteInit+6		; Save here ! (Immediate value)

	pea	(32*128*2+4).w
	jsr	tios::HeapAlloc
	addq.l	#4,a7
	tst.l	d0
	beq.s	\ExitExec
	move.w	d0,-(a7)	; Put the handle on the stack in order to ...

	tios::DEREF	d0,a0
	move.l	a0,-(a7)
	move.l	StartAdr(a5),a1
	move.w	#(32*128*2+4-1),d0
\Copy:	move.b	(a1)+,(a0)+
	dbf.s	d0,\Copy
	move.l	(a7)+,a1

	movem.l	d0-d7/a0-a6,-(a7)
	move.l	GraphCAdr(a5),a5
	move.w	#$700,d0
	trap	#1
	jsr	fer3c::ExecLevel
	moveq	#0,d0
	trap	#1
	movem.l (a7)+,d0-d7/a0-a6

	move.b	#$B2,($600017)	; Restore processor's clock
\EraseMem:
	jsr	tios::HeapFree	; Destroy level
	addq.l	#2,A7
\ExitExec:
	ifeq	HANDLEOK
	jsr	tios::HeapFree	; Free the handle of the sprites
	addq.l	#2,a7	
	endif
	bra	Main_Loop
\Exit:	rts			; Exit fer3edit





; Gestion des touches et autres
Action:
	movem.l	d0-d5/a0-a3,-(a7)
; Test if we are in the current range
	move.w	Xs_e(a5),d1
	add.w	D_SCR_X(a5),d1		
	cmp.w	X(a5),d1
	bhi.s	\ok
	move.w	d1,X(a5)
\ok:	move.w	Ys_e(a5),d1
	add.w	D_SCR_Y(a5),d1	
	cmp.w	Y(a5),d1
	bhi.s	\ok2
	move.w	d1,Y(a5)
\ok2:
	bsr	PutScreen
	bsr	PutList

	jsr	flib::idle_loop

	bsr	MoveCursor
	cmp.w	#[2nd]+KEY_LEFT,d0
	beq.s	\Speed
\NoLeft2:
	cmp.w	#[2nd]+KEY_RIGHT,d0
	beq.s	\Speed
\NoRight2:
	cmp.w	#[2nd]+KEY_UP,d0
	beq.s	\Speed
\NoUp2:
	cmp.w	#[2nd]+KEY_DOWN,d0
	beq.s	\Speed
\NoDown2:
	cmp.w	#[2nd]+'+',d0
	beq.s	\Speed
\NoPlus:
	cmp.w	#[2nd]+'-',d0
	bne.s	\Exit2nd
\Speed:
	sub.w	#[2nd],d0
	moveq	#7,d5
\loop
	bsr	MoveCursor
	dbf.s	d5,\loop
\Exit2nd:
	cmp.w	#264,d0
	bne.s	\NoEsc
	st	ExitBool(a5)
	bra	ExitKey
\NoEsc:
	cmp.w	#268,d0
	bne.s	\NoF1
	jsr	flib::zap_screen
	move.b	Current(a5),d5
	clr.b	Current(a5)
	WriteStr #20,#40,#4,Graph_Str
	bsr	SelectAnItem
	beq.s	\ExitF1
	move.w	List(a5),d4
	WriteStr #20,#40,#4,Test_Str
	move.b	#1,Current(a5)
	bsr	SelectAnItem
	beq.s	\ExitF1
	lea	TableGraphTest(a5),a0
	move.w	List(a5),d1
	move.b	d1,0(a0,d4.w)
\ExitF1:
	move.b	d5,Current(a5)
	bra	ExitKey
\NoF1:
	cmp.w	#269,d0
	bne.s	\NoF2
	move.b	#2,ExitBool(a5)
	bra	ExitKey
\NoF2:
	cmp.w	#270,d0
	bne.s	\NoF3
	move.l	StartAdr(a5),a0
	move.w	X(a5),d1
	move.b	d1,(a0)+
	move.w	Y(a5),d1
	move.b	d1,(a0)
	bra	ExitKey
\NoF3:
	cmp.w	#271,d0
	bne.s	\NoF4
	jsr	flib::zap_screen
	WriteStr #20,#40,#4,Clear_Str
	jsr	flib::idle_loop
	cmp.w	#13,d0
	bne	ExitKey
	move.l	LevelEditADR(a5),a0
	move.l	#(2*128*32-1),d0
\Loop:
	clr.b	(a0)+
	dbf.s	d0,\Loop
	bra	ExitKey
\NoF4:
	cmp.w	#272,d0
	bne.s	\NoF5
	st.b	BoxON(a5)
	move.w	X(a5),Xbox(a5)
	move.w	Y(a5),Ybox(a5)
	bra	ExitKey
\NoF5:
	cmp.w	#273,d0
	bne.s	\NoF6
	bsr	ShowMap
	bra	ExitKey
\NoF6:
	cmp.w	#274,d0
	bne.s	\NoF7
	cmp.w	#(SCREEN_Y/32-1),D_SCR_Y(a5)
	beq.s	\Goto16
	move.w	#(SCR_X/4-2),D_SCR_X(a5)
	move.w	#(SCREEN_Y/32-1),D_SCR_Y(a5)
	bra	ExitKey
\Goto16:
	move.w	#(SCR_X/2-2),D_SCR_X(a5)
	move.w	#(SCREEN_Y/16-1),D_SCR_Y(a5)
	bra	ExitKey
\NoF7:
	cmp.w	#13,d0
	bne.s	\NoEnter
	move.w	List(a5),d0
	bsr	PutData
	bra	ExitKey
\NoEnter:
	cmp.w	#32,d0
	bne.s	\NoSpace
	eor.b	#1,Current(a5)
	bra	ExitKey
\NoSpace:
	cmp.w	#257,d0
	bne.s	\NoDel
	move.w	#(65-1),d0
	bra.s	\CharacterPut
\NoDel:
	cmp.w	#46,d0
	bne.s	\NoPoint
	clr.w	List(a5)
	bra.s	ExitKey
\NoPoint:
	cmp.w	#8240,d0
	blt.s	\NoSShortCut
	cmp.w	#(8240+9),d0
	bgt.s	\NoSShortCut
	sub.w	#8240,d0
	tst.b	Current(a5)
	beq.s	\Ok
	add.w	#10,d0		; If we are in test mode, add 10 to go to test short-table
\Ok:
	bsr	ReturnAdr
	moveq	#0,d1
	move.w	Y(a5),d1
	lsl.w	#7,d1
	add.w	X(a5),d1
	adda.l	d1,a1
	move.b	(a1),d1
	move.b	d1,TableShortCut(a5,d0.w)	; Save shortcut
	bra.s	ExitKey
\NoSShortCut:
	cmp.w	#48,d0
	blt.s	\NoShortCut
	cmp.w	#(48+9),d0
	bgt.s	\NoShortCut
	sub.w	#48,d0
	tst.b	Current(a5)
	beq.s	\Ok2
	add.w	#10,d0
\Ok2:	move.b	TableShortCut(a5,d0.w),d0
	bsr	PutData
	bra.s	ExitKey
\NoShortCut:
	cmp.w	#65,d0
	blt.s	\NoAscii
	cmp.w	#(65+253),d0
	bgt.s	\NoAscii
\CharacterPut:
	sub.w	#(65-1),d0
	bsr	PutData
\NoAscii:
ExitKey:
	movem.l	(a7)+,d0-d5/a0-a3
	rts

; Move the cursor and update the list
; Entry   : D0 = Ascii-code
; Return  : update x, y, x_s, y_s, list
; Destroy : d0-d1
MoveCursor:
	cmp.w	#KEY_LEFT,d0
	bne.s	\NoLeft
	move.w	X(a5),d2
	ble.s	\NoLeft
	subq.w	#1,d2
	move.w  d2,X(a5)
	cmp.w	Xs_e(a5),d2
	bge.s	\NoLeft
	subq.w	#1,Xs_e(a5)
\NoLeft:
	cmp.w	#KEY_RIGHT,d0
	bne.s	\NoRight
	move.w	X(a5),d2
	cmp.w	#127,d2
	bge.s	\NoRight
	addq.w	#1,d2
	move.w	d2,X(a5)
	move.w	Xs_e(a5),d1
	add.w	D_SCR_X(a5),d1		; ICI
	cmp.w	d1,d2
	ble.s	\NoRight
	addq.w	#1,Xs_e(a5)
\NoRight:
	cmp.w	#KEY_UP,d0
	bne.s	\NoUp
	move.w	Y(a5),d2
	ble.s	\NoUp
	subq.w	#1,d2
	move.w	d2,Y(a5)
	cmp.w	Ys_e(a5),d2
	bge.s	\NoUp
	subq.w	#1,Ys_e(a5)
\NoUp:
	cmp.w	#KEY_DOWN,d0
	bne.s	\NoDown
	move.w	Y(a5),d2
	cmp.w	#31,d2
	bge.s	\NoDown
	addq.w	#1,d2
	move.w	d2,Y(a5)
	move.w	Ys_e(a5),d1
	add.w	D_SCR_Y(a5),d1
	cmp.w	d1,d2
	ble.s	\NoDown
	addq.w	#1,Ys_e(a5)
\NoDown:
	cmp.w	#'+',d0
	bne.s	\NoPlus
	addq.w	#1,List(a5)
\NoPlus:
	cmp.w	#'-',d0
	bne.s	\NoMoins
	tst.w	List(a5)
	beq.s	\NoMoins
	subq.w	#1,List(a5)
\NoMoins:
	rts

; Set D0 in (x,y)
PutData:
	movem.l	d0-d5/a0-a1,-(a7)
	move.l	X(a5),-(a7)	; Save X and Y on the stack
	bsr.s	PutIt
	tst.b	BoxON(a5)	; Box mode is set ?
	beq.s	\Exitb
	move.w	X(a5),d1	; Yes, so mapped the box with the item !
	cmp.w	Xbox(a5),d1
	blt.s	\NoEx
	move.w	Xbox(a5),d2
	move.w	d1,Xbox(a5)
	move.w	d2,X(a5)
\NoEx:
	move.w	Y(a5),d1
	cmp.w	Ybox(a5),d1
	blt.s	\NoEx2
	move.w	Ybox(a5),d2
	move.w	d1,Ybox(a5)
	move.w	d2,Y(a5)
\NoEx2:
	move.w	Ybox(a5),d1
	sub.w	Y(a5),d1
	move.w	Xbox(a5),d2
	move.w	X(a5),d3
	sub.w	d3,d2
\Loop1:
	move.w	d3,X(a5)
	move.w	d2,d4
\Loop2:
	bsr.s	PutIt
	addq.w	#1,X(a5)
	dbf.s	d4,\Loop2
	addq.w	#1,Y(a5)
	dbf.s	d1,\Loop1
\Exitb:
	clr.b	BoxON(a5)
	move.l	(a7)+,X(a5)	; Restore X and Y
	movem.l	(a7)+,d0-d5/a0-a1
	rts

PutIt:	movem.l	d0-d2/a0-a2,-(a7)
	bsr	ReturnAdr
	move.w	Y(a5),d1
	lsl.w	#7,d1
	add.w	X(a5),d1
	adda.w	d1,a1
	move.b	d0,(a1)
	tst.b	Current(a5)
	bne.s	\Exit
	move.b	#1,Current(a5)
	bsr	ReturnAdr
	adda.l	d1,a1
	move.b	TableGraphTest(a5,d0.w),d0
	move.b	d0,(a1)
	clr.b	Current(a5)
\Exit:	movem.l	(a7)+,d0-d2/a0-a2
	rts

ShowMap:
	move.w	List(a5),-(a7)
	jsr	flib::zap_screen
	SetFont	NORMAL
	WriteStr #10,#40,#4,Item_Str
	bsr	SelectAnItem
	jsr	flib::zap_screen
	tst.w	d0
	beq	\ExitMap
	bsr	ReturnAdr
	lea	(128*32)(a1),a1
	move.w	List(a5),d3
	moveq	#63,d1
\Loop1:
	moveq	#127,d0
\Loop2:
	move.b	-(a1),d2
	tst.w	d3	; List =0 ?
	bne.s	\Next	; Non 
	tst.b	d2	; QQchose ?
	beq.s	\No
	bra.s	\Ok
\Next:
	cmp.b	d3,d2
	bne.s	\No
\Ok:
	move.w	d1,-(a7)
	move.w	d0,-(a7)
	jsr	flib::pixel_on
	addq.w	#1,2(a7)
	jsr	flib::pixel_on
	addq.l	#4,a7
\No:
	dbf.s	d0,\Loop2
	subq.w	#1,d1
	dbf.s	d1,\Loop1
	lea	LCD_MEM,a0
	lea	(16)(a0),a0
	moveq	#63,d1
\l2:
	move.b	#%10000000,(a0)
	lea	SCREEN_X(a0),a0
	dbf.s	d1,\l2
	moveq	#-1,d0
	lea	(SCREEN_X-16)(a0),a0
	moveq	#3,d1
\l1:
	move.l	d0,(a0)+
	dbf.s	d1,\l1
	move.w	#35,-(a7)
	move.w	X(a5),-(a7)
	jsr	flib::pixel_on
	addq.l	#4,a7
	move.w	Y(a5),d0
	add.w	d0,d0
	move.w	d0,-(a7)
	move.w	#130,-(a7)
	jsr	flib::pixel_on
	addq.l	#4,a7
	jsr	flib::idle_loop
\ExitMap:
	move.w	(a7)+,List(a5)
	rts

; Put the graph No D2.l of a0 at D0.l =Absolute long (0..2..28), D1.l = Row (0..127)
PutGraph:
	movem.l	d0-d2/a0-a1,-(a7)
	lsl.l	#7,d2
	adda.l	d2,a0

	add.w	d1,d1
	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1		; D1 = 30 * D1

	add.w	d1,d0
	lea	LCD_MEM,a1
	adda.w	d0,a1
	moveq	#31,d0
\Put_Loop:
	move.l	(a0)+,(a1)
	lea	SCREEN_X(a1),a1
	dbf	d0,\Put_Loop
	movem.l	(a7)+,d0-d2/a0-a1
	rts


; Put the graph No D2.l of a0 at D0.w =Absolute long (0..2..28), D1.w = Row (0..127)
PutGraph16:
	movem.l	d0-d4/a0-a1,-(a7)
	lsl.l	#7,d2
	adda.l	d2,a0

	add.w	d1,d1
	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1		; D1 = 30 * D1

	add.w	d1,d0
	lea	LCD_MEM,a1
	adda.w	d0,a1
	moveq	#15,d0
\Put_Loop:
	move.l	(a0)+,d1
	moveq	#0,d3	; D3.w = return value
	moveq	#15,d2	; 16 bits : destination
	moveq	#31,d4	; 32 bits : source
\Bit_Loop:
	btst.l	d4,d1	; Set in 32 bits ?
	beq.s	\Ouf
	bset.w	d2,d3	; Set in 16
\Ouf:	subq.w	#2,d4	; Next bit in 32
	dbf	d2,\Bit_Loop ; Next bit in 16
	move.w	d3,(a1)	; Write on the screen
	lea	SCREEN_X(a1),a1	; ICI
	addq.l	#4,a0
	dbf	d0,\Put_Loop	; Next row
	movem.l	(a7)+,d0-d4/a0-a1
	rts

PutScreen:
	movem.l	d0-d3/a0-a1,-(a7)
; Diasble auto-ints
	move.w	#$700,d0
	trap	#1

	move.w	Xs_e(a5),d0
	move.w	Ys_e(a5),d1
	lsl.w	#7,d1	; x 128
	add.w	d1,d0
	bsr	ReturnAdr
	adda.w	d0,a1
	moveq	#0,d1	; Y position

	cmp.w	#(SCREEN_Y/32-1),D_SCR_Y(a5)
	beq.s	PutScreen32		; Put graph in 32*32
; Put a screen of 16*16 graphs
	moveq	#(SCREEN_Y/16-1),d3
\LoopY:
	moveq	#0,d0
	moveq	#((SCR_X/2-1)-1),d4	; ICI
\LoopX:
	moveq	#0,d2
	move.b	(a1)+,d2	; Read graph
	bsr	PutGraph16	; Put on the screen
	addq.w	#2,d0		; X = X + 2
	dbf.s	d4,\LoopX	; Next col
	lea	(128-((SCR_X/2)-1))(a1),a1	; Correct in table
	add.w	#16,d1		; Next row
	dbf.s	d3,\LoopY

; Eor the current graph
	move.w	Y(a5),d1
	sub.w	Ys_e(a5),d1
	mulu.w	#(SCREEN_X*16),d1
	move.w	X(a5),d0
	sub.w	Xs_e(a5),d0
	add.w	d0,d0	; x 2		
	add.w	d1,d0	; d0 = 2*(X-X_Scr) + (SCREEN_X*16)*(Y-Y_Scr)
	lea	LCD_MEM,a0
	adda.w	d0,a0
	moveq	#15,d0
\Put:	not.w	(a0)
	lea	SCREEN_X(a0),a0
	dbf.s	d0,\Put
; Enable auto-ints
	moveq	#0,d0
	trap	#1
	movem.l	(a7)+,d0-d3/a0-a1
	rts

PutScreen32:
	moveq	#(SCREEN_Y/32-1),d3
\LoopY:
	moveq	#0,d0
	moveq	#((SCR_X/4-1)-1),d4
\LoopX:
	moveq	#0,d2
	move.b	(a1)+,d2
	bsr	PutGraph
	addq.w	#4,d0
	dbf.s	d4,\LoopX
	lea	(128-((SCR_X/4)-1))(a1),a1
	add.w	#32,d1
	dbf.s	d3,\LoopY
; Invert selected graphs
	move.w	Y(a5),d1
	sub.w	Ys_e(a5),d1
	mulu.w	#(SCREEN_X*32),d1
	move.w	X(a5),d0
	sub.w	Xs_e(a5),d0
	lsl.w	#2,d0	; x 4
	add.w	d1,d0
	lea	LCD_MEM,a0
	adda.w	d0,a0
	moveq	#31,d0
\Put:	not.l	(a0)
	lea	SCREEN_X(a0),a0
	dbf.s	d0,\Put
; Enable auto-ints
	moveq	#0,d0
	trap	#1
	movem.l	(a7)+,d0-d3/a0-a1
	rts

PutList:
	movem.l	d0-d3/a0-a1,-(a7)
	bsr.s	ReturnAdr
	moveq	#0,d0
	moveq	#0,d2
	move.w	List(a5),d2

	cmp.w	#(SCREEN_Y/32-1),D_SCR_Y(a5)
	beq.s	PutList32		; Graph in 32 * 32

	moveq	#(SCR_X-2),d0
	moveq	#0,d1
	moveq	#(SCREEN_Y/16-1),d3
\Loop:
	bsr	PutGraph16
	addq.w	#1,d2
	add.w	#16,d1
	dbf.s	d3,\Loop
	movem.l	(a7)+,d0-d3/a0-a1
	rts

PutList32:
	moveq	#(SCR_X-4),d0
	moveq	#0,d1
	moveq	#(SCREEN_Y/32-1),d3
\Loop:
	bsr	PutGraph
	addq.w	#1,d2
	add.w	#32,d1
	dbf.s	d3,\Loop
	movem.l	(a7)+,d0-d3/a0-a1
	rts


; Return in a0 the ADR of the Graph-File
; Return in a1 the ADR of the level-File
; Destroy a0-a1
ReturnAdr:
	move.l	LevelEditADR(a5),a1
	move.l	GraphEditADR(a5),a0
	tst.b	Current(a5)
	beq.s	\Ok
	lea	(128*32)(a1),a1		; LevelTest Adress
	move.l	GraphTestADR(a5),a0	; Graph Test Adress
\Ok:	rts



; Select an item of the current screen (test or graph)
; Return : d0 = 1 if success, 0 else.
;	List = Item
; Destroy : d0
SelectAnItem:
\Loop:
	bsr	PutList
	jsr	flib::idle_loop
	cmp.w	#264,d0
	beq.s	\EndEsc	; Esc
	cmp.w	#KEY_UP,d0
	bne.s	\NoNUp
	tst.w	List(a5)
	ble.s	\Loop
	subq.w	#1,List(a5)
\NoNUp:
	cmp.w	#KEY_DOWN,d0
	bne.s	\NoNDown
	cmp.w	#254,List(a5)
	bge.s	\Loop
	addq.w	#1,List(a5)
\NoNDown:
	cmp.w	#65,d0
	blt.s	\NoAscii
	cmp.w	#(65+253),d0
	bgt.s	\NoAscii
	sub.w	#(65-1),d0
	move.w	d0,List(a5)
\NoAscii:
	cmp.w	#13,d0
	bne.s	\Loop
\End:
	moveq	#1,d0
	rts
\EndEsc:
	moveq	#0,d0
	rts

GraphTest:
	INCBIN	Test.P92

Graph_Str:
	dc.b "Select graph",0
Test_Str:
	dc.b "Select test ",0
Clear_Str:
	dc.b "Clear the level ? Enter=Yes",0
Item_Str:
	dc.b "Select Map-Mode-Item",0

	ifeq	LIBRARYOK-1
_library:	dc.b "fer3edit",0
	endif

	end
