;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            FAST SCROLLING ENGINE  for 	FERNANDO 3C		  ***
;***                                                                      ***
;***			Full  screen version                              ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;

; Faut-il ractualiser l'cran virtuel ?
 move.l	Xs(a6),d0
 andi.l	#$FFE0FFE0,d0
 cmp.l	XsOld(a6),d0
 beq	PrintScreen

; On ractualise l'cran virtuel...
 move.l	d0,XsOld(a6)
 movem.l d3-d7/a2-a6,-(a7)
 move.l  a7,d6		; Save the stack
 
; Calcule les coordonnes du Level
 moveq	#0,d7
 moveq	#0,d1
 move.w Xs(a6),d7
 move.w Ys(a6),d1
 lsr.w  #5,d7	; Taille niveau X = 128 = 2^7
 and.w	#(-(32-1)-1),d1
 lsl.w	#(7-5),d1
 add.w  d1,d7
 move.l d7,d5		; Stockage temporaire pour les sprites
 add.l  LevelADR(a6),d7	; d7 = Adresse du sous-cran pour le niveau

 bsr	SpriteAutoAppear	; Affiche tous les sprites en bordure
				; de l'cran
 move.l	VirtualScreen(a6),a0	; I need 8 Adresse-Registers
 moveq  #(VIRTUAL_Y-1),d0
 move.l	GraphADR(a6),d2
 moveq	#0,d1
 
LoopV1:
 exg    d7,a0		; Echange D7 et a0
			; d7 = VirtualScreenADR and a0=LevelADR+Deca

 clr.w  d1		; Clear d1
 move.b (a0)+,d1	; D1.l = Type of the graph
 lsl.w  #7,d1		; D1 = 128 * D1
 move.l d2,a1		; A1 = *GraphADR
 add.l  d1,a1		; A1 = *Graph

 clr.w  d1
 move.b (a0)+,d1
 lsl.w  #7,d1
 move.l d2,a2
 add.l  d1,a2

 clr.w  d1
 move.b (a0)+,d1
 lsl.w  #7,d1
 move.l d2,a3
 add.l  d1,a3

 clr.w  d1
 move.b (a0)+,d1
 lsl.w  #7,d1
 move.l d2,a4
 add.l  d1,a4

 clr.w  d1
 move.b (a0)+,d1
 lsl.w  #7,d1
 move.l d2,a5
 add.l  d1,a5

 clr.w  d1
 move.b (a0)+,d1
 lsl.w  #7,d1
 move.l d2,a6
 add.l  d1,a6

 clr.w  d1
 move.b (a0)+,d1
 lsl.w  #7,d1
 move.l d2,a7
 add.l  d1,a7

 moveq	#0,d3
 move.b (a0)+,d3
 lsl.w  #7,d3
 add.l d2,d3

 moveq	#0,d4
 move.b (a0)+,d4
 lsl.w  #7,d4
 add.l d2,d4

 lea    (128-VIRTUAL_X)(a0),a0		; 128 Taille niveau en x
 exg    a0,d7			; a0 = VirtualScreenADR

 moveq #31,d1
\Loop2:
 move.l (a1)+,(a0)+
 move.l (a2)+,(a0)+
 move.l (a3)+,(a0)+
 move.l (a4)+,(a0)+
 move.l (a5)+,(a0)+
 move.l (a6)+,(a0)+
 move.l (a7)+,(a0)+
 exg	a1,d3
 move.l	(a1)+,(a0)+
 exg	a1,d3
 exg	a1,d4
 move.l	(a1)+,(a0)+
 exg	a1,d4
 dbra.s d1,\Loop2
 dbra.s d0,LoopV1

 move.l d6,a7			; Restore the stack

 movem.l (a7)+,d3-d7/a2-a6

; On affiche l'cran  partir de l'cran virtuel 
PrintScreen:
 move.w Xs(a6),d0
 move.w Ys(a6),d1
 moveq	#31,d2
 and.w  d2,d0
 and.w  d2,d1

; 36 * D1 (4 * VIRTUAL_X)
 lsl.w   #2,d1
 move.w  d1,d2		; Warning : d1.uw can be different from zero !
 lsl.w   #3,d2		; Hopefully, d2.uw = 0 
 add.w   d1,d2

 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2

 moveq   #(SCREEN_Y-1),d0	; Numbers of Row

 move.l  Screen(a6),a2		; Destination
 move.l  VirtualScreen(a6),a0	; Source
 adda.l  d2,a0
 lea	2(a0),a1		; a0 and a1 are the sources.

 and.b	#$0F,d1
 beq.s	QuickPutScreen
 cmp.b	#8,d1
 blt.s	LeftShiftScreen

 sub.b	#16,d1
 neg	d1

\PutLoop:
 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsr.l   d1,d2
 move.w  d2,(a2)+

 addq.l  #4,a0
 lea	8(a1),a1

 dbra.s d0,\PutLoop

 rts

QuickPutScreen:
\PutLoop:
 moveq	#6,d2
\Sub_Loop:
 move.l	(a0)+,(a2)+
 dbf.s	d2,\Sub_Loop

 move.w	(a0)+,(a2)+
 addq.l	#6,a0

 dbra.s d0,\PutLoop
 rts

LeftShiftScreen:
\PutLoop:
 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+
 move.l  (a1)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 move.l  (a0)+,d2
 lsl.l   d1,d2
 swap	 d2
 move.w  d2,(a2)+

 addq.l	#4,a0
 lea	8(a1),a1

 dbra.s	d0,\PutLoop

 rts
