;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;

;
; ************************************************************
;
;			Fernando code
;
; ************************************************************
Sprite_Fernando:
;	a5 -> Adresse du personnage
;	d6 -> X position du perso
;	d7 -> Y position du perso
;	d4 -> KeyStat.b

 move.w Xj(a5),d6
 move.w Yj(a5),d7

; Press F5, F6 & F7 -> Speed = 1, 2 or 4
 move.w	Turbo(a6),d0
 Speed1_Key_Test
 bne.s	\FerNoF5
 move.w d0,F_Speed(a5)
 move.w #68,F_Haut(a5)
\FerNoF5:
 Speed2_Key_Test
 bne.s	\FerNoF6
 add.w	d0,d0
 move.w d0,F_Speed(a5)
 move.w #70,F_Haut(a5)
\FerNoF6:
 Speed3_Key_Test
 bne.s	\FerNoF7
 lsl.w	#2,d0
 move.w d0,F_Speed(a5)
 move.w #72,F_Haut(a5)
\FerNoF7:

; Set d4 at keystat for fast reading of Up / down / left / right / jump
 move.b keystat(PC),d4
 move.w d6,d0
 move.w d7,d1

; Left ?
 btst.b #Left_Key,d4
 bne.s	NoLeft

 move.w #1,F_Sens(a5)
 sub.w  F_Speed(a5),d0
 bsr    GetTest
 bne.s	\Okg
 move.w	d6,d0
 subq.w	#1,d0
 bsr	GetTest
 beq.s	SuiteAct
\Okg:
 move.w d0,d6
 bra.s	SuiteAct

; Right ?
NoLeft: 
 btst.b #Right_Key,d4
 bne.s	SuiteAct
 clr.w  F_Sens(a5)
 add.w  F_Speed(a5),d0
 bsr    GetTest
 bne.s	\Okd
 move.w	d6,d0
 addq.w	#1,d0
 bsr	GetTest
 beq.s	SuiteAct
\Okd:
 move.w d0,d6
SuiteAct:

; Test sortie Gauche/Droite
 cmpi.w #4080,d0	; 32 * tailleX - TaillXFer
 bls.s  \Suitegd0
 clr.w  F_Mx(a5)
 clr.w  d6
 tst.w	d0
 blt.s	\Suitegd0
 move.w #4080,d6
\Suitegd0:

; Jump to the specific action
 move.w   F_Action(a5),d0
 move.w   Action_Code_Table(pc,d0.w),d0     
 jsr      Action_Code_Table(pc,d0.w)

 bsr	Limites		; Test limits
 bsr	ReadOption	; Read the options
 
; Save coordinates
 move.w d6,Xj(a5)
 move.w d7,Yj(a5)

; Draw sprite
; moveq	#0,d2		; I have changed a few PutSrite. Now d2.w works !
 move.w	d6,d0
 move.w	d7,d1
 move.w	Dessin(a5),d2
 add.w	F_Sens(a5),d2
 bsr	PutSprite

; Print the shield
 move.w v(a6),d2
 beq.s	\Escape
 subq.w #1,d2
 move.w d2,v(a6)
 moveq	#BULLE,d2
 bsr	PutSprite
\Escape:

; Mise  jour des coordonnes du scrolling
 bsr	UpDateScrollVar

; Next Sprite
 lea	F_End(a5),a5
 rts

Action_Code_Table:
	dc.w Tombe-Action_Code_Table		; 0
	dc.w Marche-Action_Code_Table		; 2
	dc.w Saut-Action_Code_Table		; 4
	dc.w Bumper-Action_Code_Table		; 6
	dc.w Propulseur-Action_Code_Table	; 8
	dc.w Special_Saut-Action_Code_Table	; 10
	dc.w Accroche-Action_Code_Table		; 12
	dc.w PasseurAct-Action_Code_Table	; 14
	dc.w Fly-Action_Code_Table		; 16
	dc.w Grimpe-Action_Code_Table		; 18

Special_Saut:
 moveq	#SPECIAL_SAUT,d2
 bra.s	SautRoutine

Saut:
 moveq	#SAUT,d2
SautRoutine:
 move.w	d2,Dessin(a5)	; Save the correct draw
 move.w	F_St(a5),d2
 blt.s	Sau2
 and.w	#15,d2		 ; To let a tiny jump
 bne.s	SautEntry
 btst.b #Jump_Key,d4
 beq.s	SautEntry
 clr.w	F_St(a5)	; The jump if finished, now fall
SautEntry:
 move.w F_Speed(a5),d2
 sub.w  d2,F_St(a5)
 move.w d6,d0
 move.w d7,d1
 sub.w  d2,d1
 bsr    GetTest
 beq.s	SautEnd
 move.w d1,d7
SautEnd:
 rts 
Sau2:
 clr.w	F_Action(a5)
 rts			; To avoid an infinity loop

Tombe:
 move.w d6,d0
 move.w d7,d1
 add.w	F_Speed(a5),d1
 bsr	GetTest
 bne.s	\TombeL1
 move.w d7,d1
 addq.w #1,d1		; Corrige un bug <= Vitesse >1
 bsr	GetTest
 beq.s	Marche
\TombeL1:
 move.w d1,d7
 move.w #TOMBE,Dessin(a5)
 rts

Bumper:
 move.w F_St(a5),d2
 blt.s	Sau2
 move.w #BUMPER,Dessin(a5)
 bsr.s	MarcheEntry
 bra.s	SautEntry

Marche:
 btst.b #Jump_Key,d4
 bne.s	Mar1
 move.w F_Haut(a5),d2		; Fer will jump
 move.w d2,F_St(a5)
 move.w #4,F_Action(a5)
 bra.s	SautEntry

Mar1:
 btst.b #Right_Key,d4
 beq.s	Mar2
 btst.b #Left_Key,d4
 beq.s	Mar2

 tst.b	F_BWait(a5)
 beq.s	PasseTemps
 addq.b #1,F_BWait(a5)
 move.w #DEBOUT,Dessin(a5)
 rts

Mar2:
 move.b #1,F_BWait(a5)
 move.w #MARCHE,Dessin(a5)
MarcheEntry:
 move.w  F_Phase(a5),d0
 addq.w  #1,d0
 andi.w  #31,d0
 move.w  d0,F_Phase(a5)
 andi.w  #24,d0
 lsr.w   #2,d0
 add.w   d0,Dessin(a5)
 rts

PasseTemps:
 move.w	#PASSE_TEMPS,Dessin(a5)
 bra.s	MarcheEntry

Propulseur:
 move.w F_Mx(a5),d0
 bne.s	\Do_Prop
 tst.w	F_My(a5)
 beq.s	ThatsAll
\Do_Prop:
 add.w  d6,d0
 move.w d7,d1
 clr.w  F_Sens(a5)
 bsr    GetTest
 beq.s	ThatsAll
 move.w d0,d6
 add.w  F_My(a5),d1
 bsr    GetTest
 beq.s	ThatsAll
 move.w d1,d7
 rts

ThatsAll:
 clr.l  F_Mx(a5)
 clr.w	F_Action(a5)
 bra	Tombe

Accroche:
 moveq	#24,d3		; 24 is the test Hooking
 move.w #ACCROCHE,Dessin(a5)
 btst.b #Right_Key,d4
 beq.s	\Exit0
 btst.b #Left_Key,d4
 bne.s	Accroche_Exit1
\Exit0:
 bsr    MarcheEntry
Accroche_Exit1:
 btst.b #Jump_Key,d4
 bne.s	\Exit2
 btst.b	#Down_Key,d4
 beq.s	\Fall_Accroche	; Usefull ?
 move.w F_Haut(a5),d0
 move.w d0,F_St(a5)
 move.w #4,F_Action(a5)
 rts
\Exit2:
 move.w	d6,d0
 move.w	d7,d1
 bsr	Lecture
 cmp.b	d3,d2			; Test Accroche option (Hook-option)
 beq.s	\Ok_Accroche
 add.w	#15,d1
 bsr	Lecture
 cmp.b	d3,d2			; Test Accroche option (Hook-option)
 beq.s	\Ok_Accroche
\Fall_Accroche:
 clr.w  F_Action(a5)
\Ok_Accroche:
 rts

PasseurAct:
 move.w F_Phase(a5),d0
 addq.w #1,d0
 andi.w #31,d0
 move.w d0,F_Phase(a5)
 lsr.w  #4,d0
 add.w  #PASSEUR,D0
 move.w d0,Dessin(a5)
 clr.w  F_Sens(a5)

 move.w Time(a6),d1
 lsr.w  #4,d1
 andi.w #31,d1
 and.w  #$FFE0,d7
 cmpi.w #16,d1
 bls.s	\Nothing
 add.w  #32,d7
 neg.w  d1
\Nothing:
 add.w  d1,d7
 moveq	#25,d3
 bra.s	Accroche_Exit1

Fly:
; Explosion ?
 move.w  Time(a6),d0
 andi.w  #127,d0
 bne.s	\skip
 moveq	#10,d0
 move.w	d6,d1
 move.w	d7,d2
 bsr	SpriteInit
\skip:
 move.w d6,d0
 move.w d7,d1
 move.w #FLY,Dessin(a5)

; Up ?
 btst.b #Up_Key,d4
 bne.s	\NoDown

 move.w #FLY_UP,Dessin(a5)
 sub.w  F_Speed(a5),d1
 bsr    GetTest
 beq.s	SuiteAct2
 move.w d1,d7
 rts
\NoDown:
 btst.b #Down_Key,d4
 bne.s	SuiteAct2
 move.w #FLY_DOWN,Dessin(a5)
 add.w  F_Speed(a5),d1
 bsr    GetTest
 beq.s	SuiteAct2
 move.w d1,d7
SuiteAct2:
 rts

Grimpe:
 move.w	d6,d0
 move.w	d7,d1
 moveq	#GRIMPE,d3
 clr.w	F_Sens(a5)
 btst.b #Down_Key,d4
 bne.s	\No_Down
 add.w  F_Speed(a5),d1
 bsr    GetTest
 beq.s	\No_Down
 move.w d1,d7
 bra.s	\No_Up
\No_Down:
 btst.b #Up_Key,d4
 bne.s	\No_Up
 sub.w  F_Speed(a5),d1
 bsr    GetTest
 beq.s	\No_Up
 move.w d1,d7
\No_Up:
 cmpi.b #255,d4
 beq.s  \No_Next
 move.w F_Phase(a5),d2
 addq.w #1,d2
 andi.w #31,d2
 move.w d2,F_Phase(a5)
 lsr.w  #3,d2
 add.w  d2,d3
\No_Next:
 move.w	d3,Dessin(a5)
 moveq	#88,d3
 bra	Accroche_Exit1



Limites:
; Test sortie Gauche/Droite
 move.w	d6,d0
 cmpi.w #4080,d0	; 32 * tailleX - TaillXFer
 bls.s	\Suitegd
 clr.w  F_Mx(a5)	; Stop X-propulsor 
 clr.w  d6		; X = 0
 tst.w	d0
 blt.s	\Suitegd
 move.w #4080,d6	; X = 4080
\Suitegd:

; Test sortie Haut/Bas
 cmpi.w	#1004,d7
 bls.s	\Suitehb
 tst.w	d7
 blt.s	\SortieHaut
 clr.b	Mort(a6)	; You die !
 bra.s	\Suitehb
\SortieHaut:
 clr.w	F_My(a5)	; Stop Up-propulsor
 clr.w	d7		; Y=0
\Suitehb:
 rts

fer3c@000F:
ReadOption:		; Lecture des options
 move.w d6,d0
 move.w d7,d1

 clr.w  d2
 bsr    Lecture
 add.w  d2,d2
 move.w Option_Code_Table(pc,d2.w),d2     
 jsr    Option_Code_Table(pc,d2.w)

 add.w  #15,d1
 clr.w  d2
 bsr    Lecture
 add.w  d2,d2
 move.w Option_Code_Table(pc,d2.w),d2     
 jsr    Option_Code_Table(pc,d2.w)

 add.w  #15,d0
 clr.w  d2
 bsr	Lecture
 add.w  d2,d2
 move.w Option_Code_Table(pc,d2.w),d2     
 jsr    Option_Code_Table(pc,d2.w)

 sub.w  #15,d1
 clr.w  d2
 bsr	Lecture
 add.w	d2,d2
 move.w	Option_Code_Table(pc,d2.w),d2     
 jmp    Option_Code_Table(pc,d2.w)

; Une option ne peut pas changer : d0.w et d1.w
; Mais elle peut modifier d2, a0 ou a1

Option_Code_Table:	
	dc.w Rien-Option_Code_Table			;0 Vraiment rien !
	dc.w Rien-Option_Code_Table			;1
	dc.w PlateForme-Option_Code_Table		;2
	dc.w Monte-Option_Code_Table			;3
	dc.w Bijou-Option_Code_Table			;4
	dc.w OneUp-Option_Code_Table			;5
	dc.w BumperG-Option_Code_Table			;6
	dc.w Clef-Option_Code_Table			;7
	dc.w Porte-Option_Code_Table			;8
	dc.w Pic-Option_Code_Table			;9
	dc.w Haut-Option_Code_Table			;10
	dc.w Bas-Option_Code_Table			;11
	dc.w Gauche-Option_Code_Table			;12
	dc.w Droite-Option_Code_Table			;13
	dc.w Arrive-Option_Code_Table			;14
	dc.w GrosBijou-Option_Code_Table		;15
	dc.w Invulnerable-Option_Code_Table		;16
	dc.w GoFallDown-Option_Code_Table		;17
	dc.w Teleportation-Option_Code_Table		;18
	dc.w HyperVitesse-Option_Code_Table		;19
	dc.w GoLaser-Option_Code_Table			;20
	dc.w Apesanteur-Option_Code_Table		;21
	dc.w Bouton-Option_Code_Table			;22
	dc.w PorteBouton-Option_Code_Table		;23
	dc.w AccrocheOpt-Option_Code_Table		;24
	dc.w Passeur-Option_Code_Table			;25
	dc.w Voler-Option_Code_Table			;26
	dc.w Bombe-Option_Code_Table			;27
	dc.w WallExploded-Option_Code_Table		;28
	dc.w Garbesh_Collector-Option_Code_Table	;29
	dc.w A_Block-Option_Code_Table			;30
	dc.w Plan0-Option_Code_Table			;31
	dc.w Plan1-Option_Code_Table			;32
; Starting Sprites.
	dc.w Rien-Option_Code_Table			;33	Blob
	dc.w Rien-Option_Code_Table			;34	Bat
	dc.w Rien-Option_Code_Table			;35	Fish
	dc.w Rien-Option_Code_Table			;36	Fer Hunter
	dc.w Rien-Option_Code_Table			;37	Fungus
	dc.w Rien-Option_Code_Table			;38	Ghost
	dc.w Rien-Option_Code_Table			;39	Water Fall
	dc.w Rien-Option_Code_Table			;40	Special Bat
	dc.w Rien-Option_Code_Table			;41	Star
	dc.w Rien-Option_Code_Table			;42	Gray
	dc.w Rien-Option_Code_Table			;43	Scroll_R
	dc.w Rien-Option_Code_Table			;44	Shifting
	dc.w Rien-Option_Code_Table			;45	Mal de mer
	dc.w Rien-Option_Code_Table			;46	Sun
	dc.w Extra_Pente_Droite-Option_Code_Table	;47	Extra Option : Not a sprite
	dc.w Extra_Pente_Gauche-Option_Code_Table	;48	Extra Option : Not a sprite
	dc.w Rien-Option_Code_Table			;49	Eor-Xor
	dc.w Rien-Option_Code_Table			;50	Cinma
	dc.w Rien-Option_Code_Table			;51	Colonnes
	dc.w Rien-Option_Code_Table			;52	Montagne
	dc.w Rien-Option_Code_Table			;53	Tirelle
	dc.w Rien-Option_Code_Table			;54	Crabe
	dc.w Rien-Option_Code_Table			;55	Shifting 2
	dc.w Rien-Option_Code_Table			;56	Gorille
	dc.w Rien-Option_Code_Table			;57	Deca-Rol
	dc.w Rien-Option_Code_Table			;58	Mirroir
	dc.w Link_Graph_Test-Option_Code_Table		;59	Extra Option
	dc.w Rien-Option_Code_Table			;60	Anim 2
	dc.w Rien-Option_Code_Table			;61	Concentrate Scroll
	dc.w Rien-Option_Code_Table			;62	Deca_Sac
	dc.w Rien-Option_Code_Table			;63	Glooner
	dc.w Rien-Option_Code_Table			;64	Boolder
	dc.w Rien-Option_Code_Table			;65	Holo_D...
	dc.w Rien-Option_Code_Table			;66	Holo_D... 2
	dc.w Rien-Option_Code_Table			;67	FlyBoot
	dc.w Rien-Option_Code_Table			;68	Scarat
	dc.w Rien-Option_Code_Table			;69	Point_Dexter
	dc.w Rien-Option_Code_Table			;70	Bloominator
	dc.w Rien-Option_Code_Table			;71	Flamme
	dc.w Rien-Option_Code_Table			;72	Nest 1
	dc.w Rien-Option_Code_Table			;73	Nest 2
	dc.w Rien-Option_Code_Table			;74	Nest 3
	dc.w Rien-Option_Code_Table			;75	Nest 4
	dc.w Rien-Option_Code_Table			;76	Nest 5
	dc.w Rien-Option_Code_Table			;77	Nest 6
	dc.w Rien-Option_Code_Table			;78	Add-On
	dc.w Rien-Option_Code_Table			;79	Explosion 2
	dc.w Rien-Option_Code_Table			;80	Anim2 Fast
	dc.w Rien-Option_Code_Table			;81	Rotator
	dc.w Rien-Option_Code_Table			;82	Move 0
	dc.w Rien-Option_Code_Table			;83	Move 1
	dc.w Rien-Option_Code_Table			;84	Move 2
	dc.w Rien-Option_Code_Table			;85	Move 3
	dc.w Rien-Option_Code_Table			;86	Move 4
	dc.w Rien-Option_Code_Table			;86	SpriteInitAll
	dc.w GrimpeO-Option_Code_Table			;88	Stairs
	dc.w Rien-Option_Code_Table			;89	100 coins
	dc.w Rien-Option_Code_Table			;90	Power dis
	dc.w Rien-Option_Code_Table			;91	Spider
	dc.w Rien-Option_Code_Table			;92	Ber
	dc.w Rien-Option_Code_Table			;93	Butter_Fly
	dc.w Rien-Option_Code_Table			;94	Nibbles
	dc.w Rien-Option_Code_Table			;95	PacMan
	dc.w Rien-Option_Code_Table			;96	Boum
	dc.w Rien-Option_Code_Table			;97	Plane
	dc.w Rien-Option_Code_Table			;98	Easy only
	dc.w Rien-Option_Code_Table			;99	Normal only
	dc.w Rien-Option_Code_Table			;100	Hard only

PlateForme:
	movem.l d0-d2,-(a7)		; Save registers
	move.w  d1,d2		
	andi.w  #28,d2
	bne.s	\PlateFormeSuite
	and.w	#$FFE0,d1
	sub.w   #16,d1
	ble.s	\PlateFormeSuite	; blt / ble ?
	move.w  d6,d0
	bsr	GetTest			; Test if we use the plat-form we will be on a block
	beq.s	\PlateFormeSuite
	move.w  d1,d7
	bsr	Marche			; Walk on the plat-form
\PlateFormeSuite:
	movem.l (a7)+,d0-d2
A_Block:
Rien:	
	rts	; Pas trs joli mais 4 octets en moins

Monte:
	movem.l d0-d2,-(a7)
	move.w	d1,d3
	and.w	#(-(32-1)-1),d3
	sub.w	#16,d3
	move.w  d6,d0
	move.w  d7,d1
	sub.w   F_Speed(a5),d1
	bsr	GetTest
	beq.s	\skip		; Test a block
	tst.w   d1
	ble.s	\skip		; Test vertical screeen
	cmp.w	d3,d1
	bge.s	\Ok
	move.w	d3,d1
\Ok:
	move.w  d1,d7
\skip:	bsr	Marche
	movem.l (a7)+,d0-d2
	sub.w   F_Speed(a5),d1
	rts

OneUp:
	addq.w	#1,Vi(a6)
	bsr	PutLife
	bra.s	Clear

Invulnerable:
	move.w #1000,v(a6)
	bra.s	Clear

GrosBijou:
	addq.w	#7,Bj(a6)
	addq.w	#7,Coins(a6)
Bijou:
	addq.w	#1,Coins(a6)
	addq.w	#1,Bj(a6)
	bsr	PutPower
Clear:
	movem.l d0-d1/a0,-(a7)
	lsr.w  #5,d0		; X position in table
	and.w	#(-(32-1)-1),d1
	ifne	SPRITE_EXT
	move.w	d1,d2		; Y coord
;	swap	d2		; Save for disappear
	move.w	d0,d3		; "
	endif
	lsl.w	#(7-5),d1	; Y position in table. Taille niveau X = 128 = 2^7
	add.w  d0,d1
	move.l LevelTestADR(a6),a0
	clr.b  0(a0,d1.w)
	move.l LevelADR(a6),a0
	clr.b  0(a0,d1.w)
	ADD_LINK 		; Add this offset in buffer
	ifne	SPRITE_EXT
	move.w	d3,d1
	lsl.w	#5,d1		; X	Y is in d2
;	swap	d2		; Y
	move.w	#SpriteSkip+114,d0
	bsr	SpriteInit
	endif
	move.w	#4000,YsOld(a6)	; Oblige le rafraichissement de l'cran virtuel
	bsr	CopyTo2ndScreen
	movem.l (a7)+,d0-d1/A0
	rts

Clef:	
	addq.w	#1,Cf(a6)
Cl125:	
	bsr	PutKey
	bra.s	Clear

PorteBouton:
	move.b	BoutON(a6),d2
	beq.s	NoPass
	clr.b	BoutON(a6)
	movem.l d0-d1,-(a7)
	bsr	PutOFF
	movem.l (a7)+,d0-d1
	bra.s	Clear

Bouton:
	move.b	BoutON(a6),d2
	bne.s	\skip
	st	BoutON(a6)
	movem.l d0-d1,-(a7)
	bsr	PutON
	movem.l (a7)+,d0-d1
\skip:
	rts

Porte:
	move.w  Cf(a6),d2
 	beq.s	NoPass
	subq.w  #1,d2
	move.w  d2,Cf(a6)
	bra.s	Cl125

NoPass: move.w	d1,d2
	and.w	#$FFE0,d2
	cmp.w	d2,d7
	bge.s	\NoUp
	sub.w	F_Speed(a5),d7
	rts
\NoUp:  move.w	d0,d2
	and.w	#$FFE0,d2
	cmp.w	d2,d6
	blt.s	\Right
	add.w  	F_Speed(a5),d6
	rts
\Right:	sub.w	F_Speed(a5),d6
	rts

Apesanteur:
	tst.w	F_Speed(a5)
	blt.s	\skip
	neg.w	F_Speed(a5)
\skip:
	rts

BumperG:
	move.l	d1,-(a7)
	and.w	#31,d1
	cmp.w	#20,d1
	ble.s	\BumpNotOK
	move.w	#6,F_Action(a5)
	move.w	F_Haut(a5),d2
	add.w	d2,d2
	move.w	d2,F_St(a5)	     ; Puissance Bumper
\BumpNotOK:
	move.l	(a7)+,d1
	rts

Pic:
	movem.l d0-d1,-(a7)
	moveq	#$0018,d2
	and.w 	d2,d1
	eor.w 	d2,d1
	bne.s  	\PicRien
	bsr	Touche
\PicRien:
	movem.l (a7)+,d0-d1
	rts

Haut:	
	move.W #8,F_Action(a5) 
	move.w F_Speed(a5),d2
	add.w  d2,d2
	neg.w  d2
	move.w d2,F_My(a5)
	move.w #HAUT,Dessin(a5)
	rts
Bas:	
	move.w #8,F_Action(a5)
	move.w F_Speed(a5),d2
	add.w  d2,d2
	move.w d2,F_My(a5)
	move.w #BAS,Dessin(a5)
	rts

Gauche:
	move.w #8,F_Action(a5)
	move.w F_Speed(a5),d2
	add.w  d2,d2
	neg.w  d2
	move.w d2,F_Mx(a5)
	move.w #GAUCHE,Dessin(a5)
	rts

Droite:
	move.w #8,F_Action(a5)
	move.w F_Speed(a5),d2
	add.w  d2,d2
	move.w d2,F_Mx(a5)
	move.w #DROITE,Dessin(a5)
	rts

Arrive:
	move.b #LEVEL_COMPLETED,Mort(a6)
	rts

GoFallDown:
 movem.l d0-d3/a0-a1,-(a7)
 bsr	ClearTab
 move.w	d1,d3
 moveq	#2,d0		; Sprite fall down
 move.w	d6,d1		; X
 move.w	YsOld(a6),d2	; Y
 bsr	SpriteInit	; Init
 movem.l (a7)+,d0-d3/a0-a1
 rts

GoLaser:
 movem.l d0-d5/a0-a1,-(a7)
 move.w	Time(a6),d0
 andi.w	#15,d0
 bne.s	\Skip
 moveq	#4,d0		; Sprite laser
 move.w	XsOld(a6),d1	; X
 move.w	d7,d2		; Y
 moveq	#2,d4		; Speedx
 moveq	#0,d5		; Speedy
 bsr	SpriteInit	; Init
 moveq	#4,d0		; Sprite laser
 addi.w	#(32*7-20),d1	; X
 moveq	#-2,d4		; Speedx
 bsr	SpriteInit
\Skip:
 movem.l (a7)+,d0-d5/a0-a1
 rts
 

Teleportation:
 btst.b	#Down_Key,d4		; Bas est-il presse ?
 bne.s	\NotOk
 movem.l d0-d3/a0,-(a7)
 move.l	d1,d3
\Loop1:
 addi.w	#32,d1
 bsr	Lecture
 cmpi.b	#18,d2
 beq.s	\Found
 cmpi.w	#(32*32),d1	; Est-on arriv  la fin (Verticalement) du niveau ?
 bls.s	\Loop1
 moveq	#-1,d1
\Loop2:
 addi.w #32,d1
 bsr	Lecture
 cmpi.b	#18,d2
 beq.s	\Found
 cmp.w  d3,d1
 bls.s	\Loop2		; We must found one item (Teleport)
\Found:
 moveq	#$FFFFFFE0,d2
 and.w	d2,d0		; 32 * Int(x / 32)
 and.w	d2,d1		; " with y
 move.w d0,d6
 move.w d1,d7
 move.w	d0,StartX(a6)	; You need it for Multi-Player
 move.w	d1,StartY(a6)	;
 move.b #TELEPORTATION,Mort(a6)	; Fernando will restart at this new point
 movem.l (a7)+,d0-d3/a0
\NotOk:
 rts
 
HyperVitesse:
 move.w	Turbo(a6),d0
 lsl.w	#3,d0
 move.w d0,F_Speed(a5)
 rts

AccrocheOpt:
 move.w  d7,d2
 and.w   #24,d2		; Bonne hauteur dans la case ?
 bne.s	\No
 btst.b #Up_Key,d4	; Haut est-il appuye ?
 bne.s	\No
 and.w	#$FFE0,d7	; Pas d7 -> d1 sinon Crash (Tout en haut)!
 move.w #12,F_Action(a5)
\No:
 rts

GrimpeO:
 btst.b	#Up_Key,d4
 bne.s	\No
 move.w	#18,F_Action(a5)
\No:
 rts

Passeur:
 move.l d1,-(a7)
 and.w	#$FFE0,d1
 cmp.w  d7,d1
 bhi.s	\SkIp
 add.w  #17,d1
 cmp.w  d7,d1
 bls.s	\SkIp
 cmp.w	#8,F_Action(a5)
 beq.s	\SkIp		; Action = Propulsor so we don't change it.
 move.w	#14,F_Action(a5) 
\SkIp:
 move.l (a7)+,d1
 rts

Voler:
 move.w #16,F_Action(a5)
 rts

Bombe:
 movem.l d0-d1,-(a7)
 clr.w  v(a6)		; The bomb is so powerFull that the shield is destroyed
 bsr	Touche
 move.w d1,d2
 move.w d0,d1
 moveq	#32,d3		; d3 isn't destroyed by call
 bsr.s	\BombeA
 add.w  d3,d1		; Add 32
 bsr.s	\BombeA
 add.w	d3,d2		; Add 32
 bsr.s	\BombeA
 sub.w	d3,d1		; Sub 32, a square
 bsr.s	\BombeA
 movem.l (a7)+,d0-d1
 bra	Clear
\BombeA:
 moveq	#6,d0
 bsr	SpriteInit
 moveq	#10,d0
 bra	SpriteInit

WallExploded:
 movem.l d0-d5/a0-a1,-(a7)
 moveq	#$FFFFFFE0,d2
 and.w	d2,d0		; 32 * Int(x / 32)
 and.w	d2,d1		; " with y
 move.w	d1,d2 		; Position Y
 move.w	d0,d1		; Position X
 moveq	#-1,d4		; Vx
 moveq	#1,d5		; Vy
 moveq	#8,d0		; Type = Brique
 bsr	SpriteInit
 moveq	#2,d5		; speedy
 moveq	#8,d0		; Type
 bsr	SpriteInit
 add.w	#32,d1
 moveq	#1,d4
 moveq	#8,d0
 bsr	SpriteInit
 moveq	#1,d5
 moveq	#8,d0
 bsr	SpriteInit
 movem.l (a7)+,d0-d5/a0-a1
 bra	Clear
 
Garbesh_Collector:
 movem.l d0-d3/a0-a1,-(a7)
 bsr	ClearTab
 move.w	d1,d3 
 moveq	#12,d0
 bsr	SpriteInit
 movem.l (a7)+,d0-d3/a0-a1
 rts

Plan0:
 move.b Plan(a6),d2
 bne.s	SwitchBetweenPlan
Retour:
 rts

Plan1:
 move.b Plan(a6),d2
 bne.s	Retour
SwitchBetweenPlan:
 move.w #4000,YsOld(a6)	; Refresh VirtualScreen
 eori.b	#1,Plan(a6)	; Change Plan
 movem.l d0-d3/a0-a1,-(a7)
 move.l	LevelADR(a6),a0
 move.l	LevelTestADR(a6),a1
 move.b	(a0)+,d2	; Graph exchange
 moveq	#30,d3		; Test exchange
 addq.l	#1,a1
 move.l	#(32*128-2),d0
\Loop:
 move.b	(a1),d1
 cmp.b	d3,d1		; Current test = Test exchange
 bne.s	\NoInvTestToGraph
 move.b #1,(a1)+
 move.b d2,(a0)+
 bra.s	\NextLoop
\NoInvTestToGraph:
 subq.b	#1,d1	; <=> cmpi.b  #1,d1 et d1 dtruit
 bne.s	\NextLoop0
 cmp.b	(a0),d2
 bne.s	\NextLoop0
 clr.b	(a0)
 move.b	d3,(a1)
\NextLoop0:
 addq.l	#1,a0
 addq.l	#1,a1
\NextLoop:
 dbf	d0,\Loop
 movem.l (a7)+,d0-d3/a0-a1
 rts

Extra_Pente_Droite:
 movem.l d0-d2,-(a7)
 move.w  d6,d0
 addi.w  #15,d0
 andi.w  #31,d0
 andi.w  #$FFE0,d1
 neg.w   d0
 addi.w  #(32-17),d0
 add.w   d0,d1
 cmp.w   d1,d7
 bcs.s	 \Skip
 move.w  d1,d7
 bsr	 Marche
\Skip:
 movem.l (a7)+,d0-d2
 rts

Extra_Pente_Gauche:
 movem.l d0-d2,-(a7)
 move.w  d6,d0
 andi.w  #31,d0
 andi.w  #$FFE0,d1
 add.w   d0,d1
 subi.w  #16,d1
 cmp.w   d1,d7
 bcs.s	 \Skip
 move.w  d1,d7
 bsr	 Marche
\Skip:
 movem.l (a7)+,d0-d2
 rts

Link_Graph_Test:
 movem.l d0-d3/a0,-(a7)
 move.w	d0,d2
 move.w	d1,d3
 move.l	LevelADR(a6),a0
 lsr.w  #5,d0
 and.w	#(-(32-1)-1),d1
 lsl.w	#(7-5),d1	; Taille niveau X = 128 = 2^7
 add.w  d0,d1
 moveq	#0,d0
 move.b  0(a0,d1.w),d0
 lsl.l	#7,d0		; A graph is 128 Bytes long
 add.l	GraphADR(a6),d0
 move.l	d0,a0
 moveq	#31,d1
 and.w	d1,d2
 neg.w	d2
 add.w	d1,d2
 moveq	#1,d0
 lsl.l	d2,d0
\Loop:
 move.l	(a0)+,d2
 and.l	d0,d2
 bne.s	\Found
 dbf.s	d1,\Loop
 bra.s	\Skip
\Found:
 andi.w	#$FFE0,d3
 sub.w	d1,d3
 addi.w	#(31-16),d3
 cmp.w	d7,d3
 bhi.s	\Skip
 move.w	d3,d7
 bsr	Marche
\Skip:
 movem.l (a7)+,d0-d3/a0
 rts





