; ******************************************************************
;
; 				DATA-Fer3C file
;
; ******************************************************************

; Donnes globales concernant le statut (Mort)
MORT		EQU	0	; Dead
OK		EQU	1	; Alive
LEVEL_COMPLETED	EQU	2	; The level is completed
TELEPORTATION	EQU	3	; Teleportation
QUICK_EXIT	EQU	4	; The player has pressed the quik_exit key
JUMP_LEVEL	EQU	5	; Need d6 :=d5
MEMORY		EQU	6	; Show Memory and exit
NOT_A_LEVEL	EQU	7	; For link usage, skip no plat-form level
BIG_LEVEL	EQU	8	; The player has changed of sub-level
START_BIG_LEVEL	EQU	9	; Start of a big-level

; Data about scrolling and sprite-routine
FAST	EQU	1
SMALL	EQU	0


; Nombre maximal de type de niveau
MAX_TYPE_LEVEL	EQU	10	; 

; Time during the Stat_Bar will be on the screen
SHOW_STATUT_TIME	EQU	50

; Link data
MAX_LINK_BUFFER		equ	6
LINK_BUFFER_SIZE	equ	2*((MAX_LINK_BUFFER+1)/2) ; to have a 2x buffer
LINK_BYTE		equ	100

; Definition des sprites
; Warning : do not change these values without knowing what you do !
SpriteAutoStart	EQU	32	; Tous les tests >  cette valeur
				; Seront considrs comme des Auto-Sprites
				; Start of the sprites in the test-table
SpriteInitStart	EQU	11	; Nombre de sprites non Auto-Sprites
				; Number of sprites you can't activate
				; with the level
SpriteSkip	EQU	(SpriteInitStart*2+2)

SpriteCorrect	EQU	SpriteAutoStart-SpriteInitStart

MAX_SPRITE_SIZE	EQU	200	; All sprite < at this value can
				; add to the sprite buffer without any test





; ******************************************************************
;
; 			IMAGE
;
; ******************************************************************

; File 'Fernand.s16'

DEBOUT		EQU	0
MARCHE		EQU	2
BUMPER		EQU	10
SAUT		EQU	18
TOMBE		EQU	20
PASSE_TEMPS	EQU	22
HAUT		EQU	32
BAS		EQU	33
GAUCHE		EQU	31
DROITE		EQU	30
BULLE		EQU	34
SPECIAL_SAUT	EQU	35
ACCROCHE	EQU	37
PASSEUR		EQU	45
FLY_UP		EQU	47
FLY		EQU	49
FLY_DOWN	EQU	51
GRIMPE		EQU	53
FerDrawEnd	EQU	57

; File 'Enm0.s16'
FALLDOWN	EQU	0+FerDrawEnd
LASER		EQU	1+FerDrawEnd
EXP_GAUCHE	EQU	2+FerDrawEnd
EXP_HAUT	EQU	3+FerDrawEnd
EXP_DROIT	EQU	4+FerDrawEnd
EXP_BAS		EQU	5+FerDrawEnd
BRIQUE		EQU	6+FerDrawEnd
ETOILE		EQU	7+FerDrawEnd
ETOILE2		EQU	8+FerDrawEnd
SUN		EQU	9+FerDrawEnd
MONTAGNE	EQU	10+FerDrawEnd
TIRELLE		EQU	11+FerDrawEnd
FLAMME		EQU	12+FerDrawEnd
Enm0DrawEnd	EQU	13+FerDrawEnd

; File 'enm1.s16'
BLOB		EQU	0+Enm0DrawEnd
BAT		EQU	4+Enm0DrawEnd
FISH		EQU	8+Enm0DrawEnd
BLASTOID	EQU	10+Enm0DrawEnd
SCARAT		EQU	12+Enm0DrawEnd
POINT_DEXTER	EQU	14+Enm0DrawEnd
BLOOMINATOR	EQU	16+Enm0DrawEnd
Enm1DrawEnd	EQU	18+Enm0DrawEnd

; File 'enm2.s16'
GHOST		EQU	0+Enm1DrawEnd
FUNGUS		EQU	4+Enm1DrawEnd
CRABE		EQU	8+Enm1DrawEnd
GORILLE		EQU	12+Enm1DrawEnd
Enm2DrawEnd	EQU	20+Enm1DrawEnd

; File 'enm3.s16'
POWER_DIS	EQU	0+Enm2DrawEnd
SPIDER_WALK	EQU	2+Enm2DrawEnd
SPIDER_FALL	EQU	4+Enm2DrawEnd
BER		EQU	6+Enm2DrawEnd
BER_FIRE	EQU	10+Enm2DrawEnd
BUTTER_FLY	EQU	12+Enm2DrawEnd
NIBBLES		EQU	14+Enm2DrawEnd
PACMAN_1	EQU	16+Enm2DrawEnd
PACMAN_2	EQU	17+Enm2DrawEnd
PACMAN_3	EQU	18+Enm2DrawEnd
PACMAN_4	EQU	19+Enm2DrawEnd
PACMAN_22	EQU	20+Enm2DrawEnd
PACMAN_33	EQU	21+Enm2DrawEnd
BOUM		EQU	22+Enm2DrawEnd
PLANE		EQU	23+Enm2DrawEnd
Enm3DrawEnd	EQU	27+Enm2DrawEnd



; ******************************************************************
;
; 			Sprite-Fer3C header file
;
; ******************************************************************

; Toutes les dfinitions de sprites doivent tre multiples
; de Mots !

; Fernando data :

No		EQU	0
Xj		EQU	2
Yj		EQU	4
F_Count		EQU	6	; What use ?
Dessin		EQU	8
F_Haut		EQU	10
F_Sens		EQU	12
F_Action	EQU	14	; F_Action must follow F_Sens
F_Phase		EQU	16
F_St		EQU	18
F_BWait		EQU	20
F_Flag		EQU	21
F_Mx		EQU	22
F_My		EQU	24	; F_My must follow F_Mx
F_Speed		EQU	26
F_End		EQU	28

; Fernando pour multi-joueur
Up		EQU	F_End+8	;36
Down		EQU	F_End+6	;34
Left		EQU	F_End+4	;32
Right		EQU	F_End+2	;30
Jump		EQU	F_End+0	;28
F_Power		EQU	38
F_Multi_End	EQU	40		; La fin doit tre multiple de 4

; Gestion Fernando Multi Joueur
; No
TailleGest	EQU	2
G_Power		EQU	4
Gest_Multi_End	EQU	6

; Gestion du link
; No
Link_Gestion_End	EQU	2

; Big level
BIG_LEVEL_START_X	EQU	-12
BIG_LEVEL_START_Y	EQU	-10
BIG_LVL_SX	EQU	-8
BIG_LVL_SY	EQU	-6
BIG_LVL_X	EQU	-4
BIG_LVL_Y	EQU	-2
BIG_LVL_SIZE	EQU	12

; No
BIG_LVL_END	EQU	2

; FallDown ?
; No
; Xj
; Yj
Adresse		EQU	6
FD_End		EQU	8

; Laser
; No
; Xj
; Yj
LaserVx		EQU	6
LaserVy		EQU	8
LaserEND	EQU	10

; Explosion
EXP_TIME	EQU	60
; No
; Xj
; Yj
EXP_Dx		EQU	6
EXP_END		EQU	8

; Brique
; No
; Xj
; Yj
; LaserVx
; LaserVy
; LaserEND


; Sert pour tous les types Star
CAS_End		EQU	8

; Star
; No
; Xj
; Yj
; Adresse
Star_End	EQU	CAS_End


; No
Sun_End		EQU	2

; Lune (D'abord  montagne)
; No
; Sun_End

; Tirelle -Shooter
; No
; Xj
; Yj
; Adresse
Tirelle_End	EQU	CAS_End

; No
; Xj
; Yj
; Adresse
Flamme_Sens	EQU	8
Flamme_Loop	EQU	10
Flamme_End	EQU	12

; Shifting

; No
; Xj
; Yj
; Adresse
Inv_End		EQU	CAS_End

; Mal de mer ?
; No
; Xj
; Yj
; Adresse
Boat_End		EQU	CAS_End

; Eoring
; No
Eor_Graph	EQU	2
Eor_Graph2	EQU	4
Eor_End		EQU	6

; Cinema
; No
Cinema_End	EQU	2

; Garbesh_Collector

; No
Garbesh_Dessin	EQU	2
Garbesh_Test	EQU	4
; Adresse
Garbesh_Temp	EQU	8
Garbesh_End	EQU	10

; Scrolling obbligatoire vers la droite
; Right scrolling
; No
; Xj
; Yj
; Adresse
Scroll_R_End	EQU	CAS_End

; Colonne
; Column
; No
; Xj
; Yj
; Adresse
Colonne_End	EQU	CAS_End

; Start of Animated Sprite
; Blob
; No
; Xj
; Yj
; Adresse
; Dessin
Blob_Vx		EQU	10
Blob_Vy		EQU	12
Blob_A		EQU	14
Blob_End	EQU	16

; Bat
; No
; Xj
; YJ
; Adresse
; Dessin
; Blob_Vx
; Blob_Vy
; Blob_A
; Blob_End

; Fish
; No
; Xj
; Yj
; Adresse
Fish_Vy		EQU	8
Fish_Loop	EQU	10
Fish_A		EQU	12
Fish_End	EQU	14


; GLOONER
; No
; Xj
; YJ
; Adresse
; Dessin
; Blob_Vx
; Blob_Vy
; Blob_A
; Blob_End

; BOOLDER
; No
; Xj
; Yj
; Adresse
Boolder_Time	EQU	8
Boolder_C	EQU	10
Boolder_End	EQU	12

; Holo_D
; No
; Xj
; Yj
; Adresse
Holo_D_Sens	EQU	8
Holo_D_End	EQU	10

; FlyBoot
; No
; Xj
; YJ
; Adresse
; Dessin
; Blob_Vx
; Blob_Vy
; Blob_A
; Blob_End

; Blastoid
; No
; Xj
; Yj
; Adresse
; Dessin
Blastoid_Sens	EQU	10
Blastoid_Loop	EQU	12
Blastoid_End	EQU	14

; Scarat
; No
; Xj
; Yj
; Adresse
; Dessin
Scarat_Sens	EQU	10
Scarat_Loop	EQU	12
Scarat_Xj_2	EQU	14
Scarat_Sens_2	EQU	16
Scarat_Loop_2	EQU	18
Scarat_End	EQU	20

; Point dexter
; No
; Xj
; Yj
; Adresse
; Dessin
Point_Sens	EQU	10
Point_Loop	EQU	12
Point_End	EQU	14

; Bloominator
; No
; Xj
; Yj
; Adresse
; Dessin
; Point_Sens
; Point_Loop
; Point_End

; FERHUNTER
;No		EQU	0
;Xj		EQU	2
;Yj		EQU	4
;F_Speed	EQU	6
;Dessin		EQU	8
;F_Haut		EQU	10
;F_Sens		EQU	12
;F_Phase	EQU	14
;F_Action	EQU	16
;F_St		EQU	18
;F_BWait	EQU	20
;F_Mx		EQU	22
;F_My		EQU	24
;F_Count	EQU	26
FH_Bj		EQU	28
FH_V		EQU	30
FH_Adresse	EQU	32
FH_End		EQU	34

; Ghost
; No
; Xj
; Yj
; Adresse
; Dessin
; Blob_Vx
; Blob_Vy
; Blob_A
; Blob_End
Ghost_End	EQU	Blob_End

; Fungus
; No
; Xj
; Yj
; Adresse
; Dessin
Fungus_Vi	EQU	10
Fungus_A	EQU	14
Fungus_End	EQU	16


; Crabe
; No
; Xj
; Yj
; Adresse
; Dessin
; Blob_Vx
; Blob_Vy
; Blob_A
; Blob_End

; Gorille
; No
; Xj
; Yj
; Adresse
Gorille_Vx	EQU	8
Gorille_Sens	EQU	10
Gorille_A	EQU	12
Gorille_Loop	EQU	14
Gorille_End	EQU	16


; Nest
; No
; Xj
; Yj
; Adresse
Nest_T		EQU	8
Nest_Kill	EQU	10
Nest_Count	EQU	12
Nest		EQU	14
Nest_Gfx	EQU	16
Nest_End	EQU	18

; Move
; No		EQU	0
Move_V		EQU	2
Move_T		EQU	4
Move_A		EQU	6
Move_Adr	EQU	8
Move_Gfx	EQU	10
Move_Tst	EQU	11
Move_Tab	EQU	12
Move_CTst	EQU	14
Move_CAdr	EQU	16
Move_End	EQU	18


; Boss
; No
Xi	EQU	2
Yi	EQU	4
Ho	EQU	6
Do	EQU	8
Hi	EQU	10
Di	EQU	12
Nbr	EQU	14
Grph	EQU	16
Grph2	EQU	18
Element_End	EQU	20

; Plane
; No
; Xj
; Yj
; Adresse
; FORCE
PLANE_SENS	EQU	10
PLANE_TMP	EQU	12
PLANE_END	EQU	14

; Boum
; No
; Yj
; Yj
BOUM_END	EQU	6

; PacMan
; No
; Xj
; Yj
PAC_A		EQU	6
PAC_END		EQU	8

; Nibbles
SIZE_NIBBLES	EQU	20
; No
; Xj
; Yj
; Adresse
; FORCE
; DEST_X
; DEST_Y
; BUT_TMP
NIB_A		EQU	16
NIB_D		EQU	18
NIB_TABLE	EQU	20
NIB_END		EQU	20+(SIZE_NIBBLES*2)*2


; Butter-Fly
; No
; Xj
; Yj
; Adresse
; FORCE
DEST_X		EQU	10
DEST_Y		EQU	12
BUT_TMP		EQU	14
BUT_END		EQU	16


; Ber
BER_DIST	EQU	60
BER_TIME	EQU	50
; No
; Xj
; Yj
; Adresse
; FORCE
BER_A		EQU	10
BER_FS		EQU	12
BER_TMP		EQU	14
BER_END		EQU	16

; Spider
; No
; Xj
; Yj
; Adresse
FORCE		EQU	8
SPIDER_ACT	EQU	10
SPIDER_A	EQU	12
SPIDER_V	EQU	14
SPIDER_END	EQU	16

; Power
; No
; Xj
; Yj
POW_TMP		EQU	6
POW_A		EQU	8
POW_END		EQU	10

; 100 coins
; No
C100_ADR	EQU	2
C100_END	EQU	4

; Movable block
; No
; Xj
; Yj
; Adresse
MOV_BLOCK_END	EQU	8

; Master Switch
MASTER_CODE	EQU	53
; No
MASTER_TIME	EQU	2
MASTER_ADR	EQU	4
MASTER_SWT_END	EQU	6

; Master_Explosion
; No
; Xj
; Yj
; Adresse
MASTER_EXP_END	EQU	8


; Master_Invertion
; No
; Xj
; Yj
; Adresse
MASTER_INV_GFX	EQU	8
MASTER_INV_END	EQU	10

; Master rotation
; No
; Xj
; Yj
; Adresse
MASTER_ROT_END	EQU	8
