;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;
; ************************************************************
;
;		Initialisation of the sprites
;
; ************************************************************

; Inialisation du sprite No d0.w et ajout dans la 'liste-pile' 
; 	D1.W = X_Start  D2.W = Y_Start D3.W = Adresse relative
; Entry : D0.w = Which Sprite, D1.w = X_Start, D2.w = Y_Start
;	  D3.w = Adress in Level_ADR
; 
; Destroy : d0 - d5 / a0 - a2
; Warning : d5 may be destroyed if you call 'Sprite_Nest' !
; Not always but...

fer3c@0002:
SpriteInit:
 move.l	SpriteADREnd(a6),a1
SpriteInitEndBuffer:		; Program will write here !!
 move.l #0,a0			; = SpriteADR + SPRITE_BUFFER
 cmp.l	a0,a1			; To be compatible with older release !
 bcc.s	SpriteInitError		; Real buffer size = SPRITE_BUFFER + MAX_SPRITE_SIZE

 move.w	Sprite_Init_Code_Table(pc,d0.w),d0
 jsr	Sprite_Init_Code_Table(pc,d0.w)
 move.l	a1,SpriteADREnd(a6)	; Save the end of the buffer

SpriteInitError:
 rts

Sprite_Init_Code_Table:
	dc.w Sprite_Init_Fernando-Sprite_Init_Code_Table	;0
	dc.w Sprite_Init_FallDown-Sprite_Init_Code_Table	;2
	dc.w Sprite_Init_Laser-Sprite_Init_Code_Table		;4
	dc.w Sprite_Init_Explosion-Sprite_Init_Code_Table	;6
	dc.w Sprite_Init_Brique-Sprite_Init_Code_Table		;8
	dc.w Sprite_Init_Explosion2-Sprite_Init_Code_Table	;10
	dc.w Sprite_Init_Garbesh-Sprite_Init_Code_Table		;12
	dc.w Sprite_Init_Element-Sprite_Init_Code_Table		;14
	dc.w Sprite_Init_Fernando_Multi-Sprite_Init_Code_Table	;16
	dc.w Sprite_Init_Gestion_Multi-Sprite_Init_Code_Table	;18
	dc.w Sprite_Init_Link_Gestion-Sprite_Init_Code_Table	;20
	dc.w Sprite_Init_Big_Level-Sprite_Init_Code_Table	;22

	dc.w Sprite_Init_Blob-Sprite_Init_Code_Table		;0 + SpriteSkip
	dc.w Sprite_Init_Bat-Sprite_Init_Code_Table		;2
	dc.w Sprite_Init_Fish-Sprite_Init_Code_Table		;4
	dc.w Sprite_Init_Fer_Hunter-Sprite_Init_Code_Table	;6
	dc.w Sprite_Init_Fungus-Sprite_Init_Code_Table		;8
	dc.w Sprite_Init_Ghost-Sprite_Init_Code_Table		;10
	dc.w Sprite_Init_Deca_Vert-Sprite_Init_Code_Table	;12
	dc.w Sprite_Init_Special_Bat-Sprite_Init_Code_Table	;14
	dc.w Sprite_Init_Star-Sprite_Init_Code_Table		;16
	dc.w Sprite_Init_Gray-Sprite_Init_Code_Table		;18
	dc.w Sprite_Init_Scroll_R-Sprite_Init_Code_Table	;20
	dc.w Sprite_Init_Inv-Sprite_Init_Code_Table		;22
	dc.w Sprite_Init_Boat-Sprite_Init_Code_Table		;24
	dc.w Sprite_Init_Sun-Sprite_Init_Code_Table		;26
	dc.w Extra47-Sprite_Init_Code_Table			;28 Extra Option
	dc.w Extra48-Sprite_Init_Code_Table			;30 Extra Option
	dc.w Sprite_Init_Eor-Sprite_Init_Code_Table		;32
	dc.w Sprite_Init_Cinema-Sprite_Init_Code_Table		;34
	dc.w Sprite_Init_Colonne-Sprite_Init_Code_Table		;36
	dc.w Sprite_Init_Montagne-Sprite_Init_Code_Table	;38
	dc.w Sprite_Init_Tirelle-Sprite_Init_Code_Table		;40
	dc.w Sprite_Init_Crabe-Sprite_Init_Code_Table		;42
	dc.w Sprite_Init_Inv2-Sprite_Init_Code_Table		;44
	dc.w Sprite_Init_Gorille-Sprite_Init_Code_Table		;46
	dc.w Sprite_Init_Deca-Sprite_Init_Code_Table		;48
	dc.w Sprite_Init_Mirroir-Sprite_Init_Code_Table		;50
	dc.w Extra59-Sprite_Init_Code_Table			;52 Extra Option
	dc.w Sprite_Init_Anim2-Sprite_Init_Code_Table		;54
	dc.w Sprite_Init_Concentrate-Sprite_Init_Code_Table	;56
	dc.w Sprite_Init_Deca_Sac-Sprite_Init_Code_Table	;58
	dc.w Sprite_Init_Glooner-Sprite_Init_Code_Table		;60
	dc.w Sprite_Init_Boolder-Sprite_Init_Code_Table		;62
	dc.w Sprite_Init_Holo_D-Sprite_Init_Code_Table		;64
	dc.w Sprite_Init_Holo_D2-Sprite_Init_Code_Table		;66
	dc.w Sprite_Init_FlyBoot-Sprite_Init_Code_Table		;68
	dc.w Sprite_Init_Scarat-Sprite_Init_Code_Table		;70
	dc.w Sprite_Init_Point_Dexter-Sprite_Init_Code_Table	;72
	dc.w Sprite_Init_Bloominator-Sprite_Init_Code_Table	;74
	dc.w Sprite_Init_Flammes-Sprite_Init_Code_Table		;76
	dc.w Sprite_Init_Nest1-Sprite_Init_Code_Table		;78
	dc.w Sprite_Init_Nest2-Sprite_Init_Code_Table		;80
	dc.w Sprite_Init_Nest3-Sprite_Init_Code_Table		;82
	dc.w Sprite_Init_NestA-Sprite_Init_Code_Table		;84
	dc.w Sprite_Init_NestB-Sprite_Init_Code_Table		;86
	dc.w Sprite_Init_NestC-Sprite_Init_Code_Table		;88
	dc.w Sprite_Init_Add_On-Sprite_Init_Code_Table		;90
	dc.w Sprite_Init_Explosion2-Sprite_Init_Code_Table	;92
	dc.w Sprite_Init_Anim2_Fast-Sprite_Init_Code_Table	;94
	dc.w Sprite_Init_Rot-Sprite_Init_Code_Table		;96
	dc.w Sprite_Init_Move0-Sprite_Init_Code_Table		;98
	dc.w Sprite_Init_Move1-Sprite_Init_Code_Table		;100
	dc.w Sprite_Init_Move2-Sprite_Init_Code_Table		;102
	dc.w Sprite_Init_Move3-Sprite_Init_Code_Table		;104
	dc.w Sprite_Init_Move4-Sprite_Init_Code_Table		;106
	dc.w Sprite_Init_All-Sprite_Init_Code_Table		;108
	dc.w Extra88-Sprite_Init_Code_Table			;110 Extra Option
	dc.w Sprite_Init_100_Coins-Sprite_Init_Code_Table	;112
	dc.w Sprite_Init_Pow-Sprite_Init_Code_Table		;114
	dc.w Sprite_Init_Spider-Sprite_Init_Code_Table		;116
	dc.w Sprite_Init_Ber-Sprite_Init_Code_Table		;118
	dc.w Sprite_Init_Butter_Fly-Sprite_Init_Code_Table	;120
	dc.w Sprite_Init_Nibbles-Sprite_Init_Code_Table		;122
	dc.w Sprite_Init_PacMan-Sprite_Init_Code_Table		;124
	dc.w Sprite_Init_Boum-Sprite_Init_Code_Table		;126
	dc.w Sprite_Init_Plane-Sprite_Init_Code_Table		;128
	dc.w Sprite_Init_Easy-Sprite_Init_Code_Table		;130
	dc.w Sprite_Init_Normal-Sprite_Init_Code_Table		;132
	dc.w Sprite_Init_Hard-Sprite_Init_Code_Table		;134
	

Extra47:
	move.l	LevelTestADR(a6),a0
	move.b	#47,0(a0,d3.w)
	rts

Extra48:
	move.l	LevelTestADR(a6),a0
	move.b	#48,0(a0,d3.w)
	rts

Extra59:
	move.l	LevelTestADR(a6),a0
	move.b	#59,0(a0,d3.w)
	rts

Extra88:
	move.l	LevelTestADR(a6),a0
	move.b	#88,0(a0,d3.w)
	rts

Sprite_Init_Easy:
	cmp.l	#(EASY_DEC*65536+EASY_INV),Diff(a6)
	beq.s	Go_Set
	bra.s	No_Set

Sprite_Init_Normal:
	cmp.l	#(NORMAL_DEC*65536+NORMAL_INV),Diff(a6)
	beq.s	Go_Set
	bra.s	No_Set

Sprite_Init_Hard:
	cmp.l	#(HARD_DEC*65536+HARD_INV),Diff(a6)
	bne.s	No_Set
Go_Set:	move.l	LevelADR(a6),a0
	move.b	0(a0,d3.w),d0
	move.l	LevelTestADR(a6),a0
	move.b	d0,0(a0,d3.w)
No_Set:	move.l	LevelADR(a6),a0
	clr.b	0(a0,d3.w)
	rts

Sprite_Init_Fernando:
 clr.w  No(a1)
 move.w StartX(a6),Xj(a1)
 move.w StartY(a6),Yj(a1)
 move.w Turbo(a6),F_Speed(a1)
 move.w #68,F_Haut(a1)
 clr.l  F_Sens(a1)	; clr.w  F_Sens(a1)	& clr.w  F_Action(a1)
 clr.l	F_Mx(a1)	; clear F_Mx and F_My
 lea	F_End(a1),a1
 rts

Sprite_Init_Fernando_Multi:
 bsr	Sprite_Init_Fernando
 move.w	#16,(No-F_End)(a1)
 move.w	Bj(a6),(F_Power-F_End)(a1)
 lea	(F_Multi_End-F_End)(a1),a1
 rts

Sprite_Init_Gestion_Multi:
 move.w	#18,No(a1)
 move.w	NbrJoueur(a6),d0
 mulu.w #(F_Multi_End/4),d0
 subq.w	#1,d0
 move.w	d0,TailleGest(a1)
 clr.w	G_Power(a1)
 lea	Gest_Multi_End(a1),a1
 rts

Sprite_Init_FallDown:
 move.w #2,No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 lea	FD_End(a1),a1
 rts

Sprite_Init_Brique:
 moveq #8,d0
LaserEntry:
 move.w d0,No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d4,LaserVx(a1)
 move.w d5,LaserVy(a1)
 lea	LaserEND(a1),a1
 rts

Sprite_Init_Laser:
 moveq #4,d0
 bra.s	LaserEntry

Sprite_Init_Explosion2:
 moveq #10,d0
 bra.s	Explode

Sprite_Init_Explosion:
 moveq #6,d0
Explode:
 move.w d0,No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 clr.w  EXP_Dx(a1)
 lea	EXP_END(a1),a1
 rts

Sprite_Init_Garbesh:
 move.w #12,No(a1)
 move.w d3,Adresse(a1)
 move.w #64,Garbesh_Temp(a1)
 add.w  #128,d3
 move.l LevelTestADR(a6),a0
 move.b 0(a0,d3.w),Garbesh_Test(a1)
 move.l LevelADR(a6),a0
 move.b 0(a0,d3.w),Garbesh_Dessin(a1)
 lea	Garbesh_End(a1),a1
 rts

Sprite_Init_Element:
 move.w	#14,No(a1)

; Calcul de l'adresse du graph de l'lment du boss
 moveq	#0,d0
 moveq	#0,d1
 move.w	NbrPhase(a6),d0
 move.w	TaillePhase(a6),d1
 mulu.w	d1,d0
 add.l	LevelADR(a6),d0

 move.l	d3,d1
 lsl.l	#5,d1
 add.l	d1,d0
 move.l	d0,Grph(a1)

 move.w	d3,d0
 add.w	d0,d0
 addq.w	#1,d0
 move.w	d0,Nbr(a1)

 bsr	InitHandD

 lea	Element_End(a1),a1
 rts

Sprite_Init_Link_Gestion:
 move.w	#20,(a1)+
; move.w #20,No(a1)
; lea	Link_Gestion_End(a1),a1
 rts


Sprite_Init_Blob:
 moveq #(2*SpriteInitStart+2),d0
Sprite_Init_Blob_Entry:
 move.w d0,No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w	Turbo(a6),Blob_Vx(a1)
 move.l SpriteADR(a6),a0
 move.w Xj(a0),d0
 cmp.w  d1,d0
 bhi.s	\Ok
 neg.w  Blob_Vx(a1)
\Ok:

 move.w Turbo(a6),Blob_Vy(a1)
 lea	Blob_End(a1),a1
 rts

Sprite_Init_Bat:
 moveq #(2*SpriteInitStart+4),d0
 bra.s	Sprite_Init_Blob_Entry

Sprite_Init_Special_Bat:
 moveq #(2*SpriteInitStart+16),d0
 bra.s	Sprite_Init_Blob_Entry

Sprite_Init_Crabe:
 moveq #(2*SpriteInitStart+40),d0
 bra.s	Sprite_Init_Blob_Entry

Sprite_Init_Glooner:
 move.l	a0,a2
 moveq #(2*SpriteInitStart+56),d0
 addq.w	#1,d2
 bsr	Sprite_Init_Blob_Entry
 move.l	a2,a0
 moveq #(2*SpriteInitStart+56),d0
 addq.w	#5,d1
 addq.w	#5,d2
 bsr	Sprite_Init_Blob_Entry
 move.l	a2,a0
 moveq #(2*SpriteInitStart+56),d0
 addq.w	#5,d1
 addq.w	#5,d2
 bsr	Sprite_Init_Blob_Entry
 move.l	a2,a0
 moveq #(2*SpriteInitStart+56),d0
 addq.w	#5,d1
 addq.w #4,d2
 bra.s	Sprite_Init_Blob_Entry

Sprite_Init_FlyBoot:
 moveq	#(2*SpriteInitStart+62),d0
 bra.s	Sprite_Init_Blob_Entry


Sprite_Init_Fish:
 move.w #(2*SpriteInitStart+6),No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w	Turbo(a6),d0
 neg.w	d0
 move.w	d0,Fish_Vy(a1)
 move.w	#(32*3),Fish_Loop(a1)
 lea Fish_End(a1),a1
 rts

Sprite_Init_Fer_Hunter:
 move.w #(2*SpriteInitStart+8),No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,FH_Adresse(a1)
 move.w Turbo(a6),F_Speed(a1)
 move.w #68,F_Haut(a1)
 clr.w  F_Sens(a1)
 clr.w  F_Action(a1)
 clr.w	FH_V(a1)
 move.w #100,FH_Bj(a1)
 lea	FH_End(a1),a1
 rts
 
Sprite_Init_Fungus:
 move.w #(2*SpriteInitStart+10),No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w #20,Fungus_Vi(a1)
 lea	Fungus_End(a1),a1
 rts

Sprite_Init_Ghost:
 move.w #(2*SpriteInitStart+12),No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 lea	Ghost_End(a1),a1
 rts



; If no special effects, ...
 ifeq	SPECIAL_EFFECT
Sprite_Init_Colonne:
Sprite_Init_Inv2:
Sprite_Init_Rot:
Sprite_Init_Mirroir:
Sprite_Init_Inv:
Sprite_Init_Boat:
Sprite_Init_Montagne:
Sprite_Init_Sun:
Sprite_Init_Cinema:
 rts
 endif
 ifeq	SPECIAL_EFFECT-1
Sprite_Init_Colonne:
 moveq	#(2*SpriteInitStart+34),d0
 move.w d1,d2
 lsr.w  #5,d2
 andi.w #15,d2
 bra.s	StarEntry

Sprite_Init_Inv2:
 moveq	#(2*SpriteInitStart+42),d0
 bra.s	StarEntry

Sprite_Init_Rot:
 moveq	#(2*SpriteInitStart+78),d0
 and.w	#31,d1
 bra.s	StarEntry

Sprite_Init_Mirroir:
 moveq	#(2*SpriteInitStart+48),d0
 bra.s	StarEntry

Sprite_Init_Inv:
 moveq	#(2*SpriteInitStart+24),d0
 bra.s	StarEntry

Sprite_Init_Boat:
 moveq	#(2*SpriteInitStart+26),d0
 bra.s	StarEntry
 endif

Sprite_Init_Star:
 moveq	#(2*SpriteInitStart+18),d0
StarEntry:
 move.w	d0,No(a1)
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 lea	Star_End(a1),a1
 rts

Sprite_Init_Scroll_R:
 moveq	#(2*SpriteInitStart+22),d0
 move.w Xs(a6),d1
 bra.s	StarEntry

Sprite_Init_Concentrate:
 moveq	#(2*SpriteInitStart+52),d0
 bra.s	StarEntry

Sprite_Init_All:
 moveq	#(2*SpriteInitStart+82),d0
 bra.s	StarEntry

Sprite_Init_Tirelle:
 moveq	#(2*SpriteInitStart+38),d0
 addi.w	#16,d2
 bra.s	StarEntry




; If special effects
 ifeq	SPECIAL_EFFECT-1
Sprite_Init_Sun:
 moveq #(2*SpriteInitStart+28),d0
SunEntry:
 move.w d0,(a1)+
; move.w d0,No(a1)
; lea	Sun_End(a1),a1
 rts

Sprite_Init_Montagne:
 moveq #(2*SpriteInitStart+36),d0
 bra.s	SunEntry

Sprite_Init_Cinema:
; move.w #(2*SpriteInitStart+32),No(a1)
; lea	Cinema_End(a1),a1
 move.w #(2*SpriteInitStart+32),(a1)+
 rts
 endif

Sprite_Init_Eor:
 moveq #(2*SpriteInitStart+30),d0 
EorEntry:
 move.w d0,No(a1)
 moveq	#0,d0
 move.l	LevelADR(a6),a0
 move.b 0(a0,d3.w),d0
 lsl.w  #7,d0
 add.l  GraphADR(a6),d0
 move.l d0,Eor_Graph(a1)
 lea	Eor_End(a1),a1
 rts

Sprite_Init_Deca:
 moveq	#(2*SpriteInitStart+46),d0
 bra.s	EorEntry

Sprite_Init_Deca_Vert:
 moveq #(2*SpriteInitStart+14),d0
 bra.s	EorEntry

Sprite_Init_Gray:
 moveq #(2*SpriteInitStart+20),d0
 bra.s	EorEntry

Sprite_Init_Anim2:
 moveq #(2*SpriteInitStart+50),d0
 bra.s	EorEntry

Sprite_Init_Deca_Sac:
 moveq #(2*SpriteInitStart+54),d0
 bra.s	EorEntry

Sprite_Init_Anim2_Fast:
 moveq #(2*SpriteInitStart+76),d0
 bra.s	EorEntry




Sprite_Init_Gorille:
 move.w	#(2*SpriteInitStart+44),No(a1)
 move.w d1,Xj(a1)
 addi.w #16,d2
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w #(2*32),Gorille_Loop(a1)
 move.w Turbo(a6),Gorille_Vx(a1)
 clr.w	Gorille_Sens(a1)
 lea	Gorille_End(a1),a1
 rts

Sprite_Init_Boolder:
 move.w	#(2*SpriteInitStart+58),No(a1)
 addq.w	#7,d1
 addq.w	#7,d2
 move.w d1,Xj(a1)
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w #20,Boolder_Time(a1)
 clr.w	Boolder_C(a1)
 lea	Boolder_End(a1),a1
 rts

Sprite_Init_Holo_D:
 moveq #60,d0
Init_Holo_D_Entry:
 move.w	#(2*SpriteInitStart+60),No(a1)
 move.w d1,Xj(a1)
 addi.w	#16,d2
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w	d0,Holo_D_Sens(a1)
 lea	Holo_D_End(a1),a1
 rts

Sprite_Init_Holo_D2:
 moveq #-60,d0
 bra.s	Init_Holo_D_Entry



Sprite_Init_Scarat:
 move.w	#(2*SpriteInitStart+64),No(a1)
 move.w d1,Xj(a1)
 addi.w	#16,d2
 move.w d2,Yj(a1)
 move.w d3,Adresse(a1)
 move.w	#SCARAT,Dessin(a1)
 move.w Turbo(a6),d0
 move.w	d0,Scarat_Sens(a1)
 move.w	#60,Scarat_Loop(a1)
 clr.w	Scarat_Xj_2(a1)
 move.w d0,Scarat_Sens_2(a1)
 move.w	#16,Scarat_Loop_2(a1)
 lea	Scarat_End(a1),a1
 rts


Sprite_Init_Point_Dexter:
 move.w #(2*SpriteInitStart+66),No(a1)
 move.w	#POINT_DEXTER,Dessin(a1)
 move.w	#80,Point_Loop(a1)
Point_Dexter_Init_Entry:
 move.w	d1,Xj(a1)
 addq.w	#7,d2
 move.w	d2,Yj(a1)
 move.w	d3,Adresse(a1)
 move.w	Turbo(a6),Point_Sens(a1)
 lea	Point_End(a1),a1
 rts

Sprite_Init_Bloominator:
 move.w #(2*SpriteInitStart+68),No(a1)
 move.w #16,Point_Loop(a1)
 move.w #BLOOMINATOR,Dessin(a1)
 addq.w	#7,d1
 addi.w	#9,d2
 bra.s	Point_Dexter_Init_Entry
 

Sprite_Init_Flammes:
 moveq	#(2*SpriteInitStart+70),d0
 move.w	d0,No(a1)
 move.w	d1,Xj(a1)
 add.w	#16,d2
 move.w	d2,Yj(a1)
 move.w	d3,Adresse(a1)
 move.w	Turbo(a6),Flamme_Sens(a1)
 move.w #64,Flamme_Loop(a1)
 lea	Flamme_End(a1),a1
 move.w	d0,No(a1)
 addi.w	#(64),d1
 move.w	d1,Xj(a1)
 move.w	d2,Yj(a1)
 move.w	d3,Adresse(a1)
 move.w	#-1,Flamme_Sens(a1)
 move.w #64,Flamme_Loop(a1)
 lea	Flamme_End(a1),a1 
 rts



Sprite_Init_Nest1:
 moveq	#72,d0
 moveq	#16,d4
 moveq	#0,d5
 bra.s	Sprite_Init_Nest

Sprite_Init_Nest2:
 moveq	#73,d0
 moveq	#80,d4
 moveq	#0,d5
 bra.s	Sprite_Init_Nest

Sprite_Init_Nest3:
 moveq	#74,d0
 moveq	#127,d4
 moveq	#0,d5
 bra.s	Sprite_Init_Nest

Sprite_Init_NestA:
 moveq	#75,d0
 moveq	#16,d4
 moveq	#4,d5
 bra.s	Sprite_Init_Nest

Sprite_Init_NestB:
 moveq	#76,d0
 moveq	#40,d4
 moveq	#4,d5
 bra.s	Sprite_Init_Nest

Sprite_Init_NestC:
 moveq	#77,d0
 moveq	#90,d4
 moveq	#4,d5
Sprite_Init_Nest:
 move.w #(2*SpriteInitStart+72),No(a1)
 move.w	d1,Xj(a1)
 move.w	d2,Yj(a1)
 move.w	d3,Adresse(a1)
 move.w	d4,Nest_T(a1)
 move.w	d5,Nest_Kill(a1)
 clr.w	Nest_Count(a1)
 move.w	d0,Nest(a1)
 move.l LevelADR(a6),a0
 move.b 0(a0,d3.w),Nest_Gfx(a1)
 clr.b	0(a0,d3.w)
 lea	Nest_End(a1),a1
ErrorAddOn:
 rts

Sprite_Init_Add_On:
 move.l	InitAddOnADR(a6),a2
 move.l	a2,d0		; because tst.l	a6 doesn't work...
 beq.s	ErrorAddOn
 moveq	#(2*SpriteInitStart+74),d0
 jmp	(a2)


Sprite_Init_Move0:
 moveq	#82,d0	; Test
 moveq	#0,d4	; Tab
 bra.s	Sprite_Init_Move_Entry
Sprite_Init_Move1:
 moveq	#83,d0	; Test
 moveq	#8,d4	; Tab
 bra.s	Sprite_Init_Move_Entry
Sprite_Init_Move2:
 moveq	#84,d0	; Test
 moveq	#16,d4	; Tab
 bra.s	Sprite_Init_Move_Entry
Sprite_Init_Move3:
 moveq	#85,d0	; Test
 moveq	#24,d4	; Tab
 bra.s	Sprite_Init_Move_Entry
Sprite_Init_Move4:
 moveq	#86,d0	; Test
 moveq	#32,d4	; Tab
Sprite_Init_Move_Entry:
 move.w #(2*SpriteInitStart+80),No(a1)
 lea	M_Tab(PC),a0
 move.w	0(a0,d4.w),Move_V(a1)
 move.w	#32,Move_T(a1)
 clr.w	Move_A(a1)
 move.w	d3,Move_Adr(a1)
 move.w	d3,Move_CAdr(a1)
 move.l LevelADR(a6),a0
 move.b	0(a0,d3.w),Move_Gfx(a1)
 move.l	LevelTestADR(a6),a0
 move.w	d3,d1
 and.w	#127,d1
 move.b	0(a0,d1.w),d1
 move.b	d1,Move_Tst(a1)
 move.b	d1,0(a0,d3.w)
 move.w	d4,Move_Tab(a1)
 move.b	d0,Move_CTst(a1)
 lea	Move_End(a1),a1
 rts

Sprite_Init_100_Coins:
 move.w	#(2*SpriteInitStart+84),No(a1)
 move.l LevelTestADR(a6),a0
 move.l a0,d2
 move.w	#(128*32-1),d0
 moveq	#14,d1
\l1:
 cmp.b	(a0)+,d1
 beq.s	\Found
 dbf	d0,\l1
\Found:
 clr.b	-(a0)
 sub.l	d2,a0
 move.w	a0,C100_ADR(a1)
 addq.l	#C100_END,a1
 rts

 ifeq	SPRITE_EXT
	Sprite_Init_Pow:
	Sprite_Init_Spider:
	Sprite_Init_Ber:
	Sprite_Init_Butter_Fly:
	Sprite_Init_Nibbles:
	Sprite_Init_PacMan:
	Sprite_Init_Boum:
	Sprite_Init_Plane:
	rts
 endif
 ifne	SPRITE_EXT
	include "Spr_Exti.s"
 endif
