;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;
; storage macros.
; The original macro was made by Patrick Davidson.

offset   set      0

rs	MACRO
\1	set	offset		; Set \1 to the current value of offset
offset	set	offset+\2	; New value of offset
	dcb.b	\2,0		; allocate memory
	ENDM

rsl	MACRO
\1	set	offset		; Set \1 to the current value of offset
offset	set	offset+4	; New value of offset
	dc.l	\2		; allocate memory and set to \2
	ENDM

rsw	MACRO
\1	set	offset		; Set \1 to the current value of offset
offset	set	offset+2	; New value of offset
	dc.w	\2		; allocate memory and set to \2
	ENDM

rsb	MACRO
\1	set	offset		; Set \1 to the current value of offset
offset	set	offset+1	; New value of offset
	dc.b	\2		; allocate memory and set to \2
	ENDM


rsno	MACRO
\1	set	offset
	ENDM


fer3c@0001:
 rs	Screen,4		; ADR of current screen		+0
 rsno	Vitesse
 rs	VirtualScreen,2		; ADR of virtual screen		+4
 rs	TaillePhase,2		; Or Speed of the boss and height of one phase

 rs	Table,4			; Table of ADR of the 2 screens	+8
 rs	Phase,1			; Must be NULL ( Current screen = 0 or 2 ?)	;12
 rs	Mort,1			; Fernando dies ?		+13

 rs	LevelADR,4		; ADR of the graph-level file	+14
 rs	LevelTestADR,4		; ADR of the test-level file	+18

 rs	SpriteADR,4		; ADR of sprite's buffer	+22
 rs	SpriteADREnd,4		; ADR of the end of the sprite's buffer

 rsno	Phase2ADR		; ADR of Phase 2 (Boss)
 rs	GraphADR,4		; Or ADR of the graph-file	+30

 rsno	Phase1ADR		; ADR of phase 1 (Boss)
 rs	StartX,2		; X_Start			+34
 rs	StartY,2		; Y_Start			+36

 rsno	NbrElement		; Number of the elements of the boss
 rs	XsOld,2			; (X_Scrolling_Old / 32) *32	+38
 rsno	NbrPhase		; Number of the phases of the boss
 rs	YsOld,2			; Or (Y_Scrolling_Old / 32) *32

 rs	Xs,2			; X_Scrolling			+42
 rs	Ys,2			; Y_Scrolling
 rs	XsNew,2			; New X_Scrolling		+46
 rs	YsNew,2			; New Y_Scrolling

 rsb	Frame_Time,23		; Time of one frame (23 * processor clock rate = 1/60 s)	+50
 rs	Link,1			; Link flag
 rs	Clock,2			; Clock (Long)			+52
 rs	Time,2			; Time  (Word)			+54

 rs	ExecAddOnADR,4		; Adress of the exec AddOn/plugin +56
 rs	InitAddOnADR,4		; Adress of the init AddOn/plugin +60

 rsw	Turbo,1			; Turbo (2) or not (1) ?	+64

 rs	NbrJoueur,2		; Number of players - 1		+66

 rsno	Refresh
 rs	BoutON,1		; Switch ON / OFF		+68
 rs	Plan,1			; Current plan = 0 / 1		+69
 rsno	BossLife		; Life of the boss
 rs	Cf,2			; Or number of Keys		+70
 rs	Vi,2			; Lifes				+72
 rs	Bj,2			; Power				+74
 rs	Coins,2			; Coins collected		+76
 rs	v,2			; Invulnerable ?		+78
 rsno	Phase1			; No of phase 1
 rs	ComptBj,2		; Or Max Power			+80
 rsno	Phase2			; No of Phase 2
 rs	ComptVi,2		; Or Max one-up			+82

 rsw	Diff,EASY_DEC		; How much power will be dec (Easy Mode) +84
 rsw	Diff2,EASY_INV		; How much time perso = invulnerable (") +86

 rs	str,9			; String for "Convert number to string" +88
 rs	strend,1

 rs	Save,16			; Save	: +98

 ifeq	LINK_MODE-1
 rsno	LinkDataStart
Buffer_Receive:		; For auto-int
 rs	BufferR,4
 rs	BuffeR2,LINK_BUFFER_SIZE
Buffer_Send:		; For auto-int
 rs	BufferS,4
 rs	BuffrS2,LINK_BUFFER_SIZE
 rs	RC_Data,(LINK_BUFFER_SIZE-2)	; To have a 2x length
 rs	offset_table,4			; Some data
 rs	Temp~~1,16			; The table : 8 Offset max
 rsno	LinkDataEnd

 rs	OldInt4,4
 rs	OldInt5,4
 rs	OldInt6,4
 rs	Score,4

 endif

 ifeq	LOOK-1
 rs	Look_X,2		; Look x data
 rs	Look_Y,2		; Look y data
 endif

 ifeq	PT_STATUT-1
 rs	Delai_Statut,2
 endif

 ifeq	AUTO_LOW-1
 rs	LowFlag,1		; Auto-low flag
 endif

 ifeq	DEBUG-1
 rs	Save_Freq,1		; For debug usage only
 endif

	EVEN			; For aligned words

; End of variables

 ifeq	LINK_MODE-1
ADD_LINK	MACRO
	tst.b	Link(a6)	; Link ?
	beq.s	\NoAddToLink	; No / yes
	bsr	Add_To_Send
\NoAddToLink:
		ENDM
 endif
 ifeq	LINK_MODE
ADD_LINK	MACRO
		ENDM
 endif